<?php
require_once('../../../../dhtmlx/phpconnector/grid_connector.php');
require_once('../../../../dhtmlx/phpconnector/grid_config.php');
require_once('../../../../dhtmlx/phpconnector/db_postgre.php');

require_once '../../autoload.php';

$whereclause = '';
if(isset($_GET["dhx_filter"]))
{
  foreach($_GET["dhx_filter"] as $k => $v)
  {
    if($v != '')
	{
      switch($k)
      {
        case 2:  {
          $ldate = explode("|", $v);

          if($ldate[0] != '')
          {
            $whereclause .= " and audit.date >= to_timestamp('{$ldate[0]} 00:00:00','DD/MM/YYYY HH24:MI:SS')";
          }

          if($ldate[1] != '')
          {
            $whereclause .= " and audit.date <= to_timestamp('{$ldate[1]} 23:59:59' ,'DD/MM/YYYY HH24:MI:SS')";
          }

        }break;
        case 5:  
		{
          $whereclause .= " and audit.status_id = {$v}";
        }
		break;
        default:;
      }
    }
  }
}


function my_insert($data){
  $conn = get_dbconnection();
  $sql = 'insert into audit(origine,date,status_id,title) values(0,now(),'.STATUS_PLANNED_ID.',\'New audit\') returning id;';

  if($query = pg_query($conn,$sql)){
     if(!($row = pg_fetch_row($query)))
     {
      $data->invalid();
      return;
     }
     $data->set_new_id($row[0]);
     $data->success(); // marks an operation as finished

  }else
  {
    $data->invalid();
  }
}


function my_update($data){

  $conn = get_dbconnection();
  $sql = 'update audit';
  $sql .= ' set comment = \''.pg_escape_string($conn,$data->get_value('comment')).'\'';
  $sql .= ' ,title = \''.pg_escape_string($conn,$data->get_value('title')).'\'';

  if($data->get_value('inst_id') != '-1' && $data->get_value('inst_id') != '' )
  {
    $sql .= ' ,inst_id = '.$data->get_value('inst_id');
  }else{
    $sql .= ' ,inst_id = null';
  }

  if($data->get_value('dep_id') != '-1' && $data->get_value('dep_id') != '' )
  {
    $sql .= ' ,dep_id = '.$data->get_value('dep_id');
  }else{
    $sql .= ' ,dep_id = null';
  }

  if($data->get_value('date') != '')
    $sql .= ' ,date = to_timestamp(\''.pg_escape_string($conn,$data->get_value('date')).'\',\'DD/MM/YYYY\')';
  else {
    $sql .= ' ,date = null';
  }
  $sql .= ' ,status_id = '.$data->get_value('status_id');
  $sql .= ' ,origine = '.$data->get_value('origine');
  $sql .= ' ,type = '.$data->get_value('audit_type');
  $sql .= ' where id =  '.$data->get_id().';commit;';

  if(!pg_query($conn,$sql)){
     $data->invalid();
  }else
    $data->success(); // marks an operation as finished
}

function my_delete($data){

  $sql = 'update audit set removed = true where id = '.$data->get_id().';commit;';

  $conn = get_dbconnection();
  if(!pg_query($conn,$sql)){
     $data->invalid();
  }else
  {
    $data->success(); // marks an operation as finished
  }
}

$conn = get_dbconnection();

if($conn )
{
	$opts = new OptionsConnector($conn,"Postgre");	$opts->render_sql("select id as value,status_name as label from statuslist where type ilike '%|audit|%'","value","value,label");
	$opts1 = new OptionsConnector($conn,"Postgre");	$opts1->render_sql("select id as value,name as label from institution where id != -1 union select  -1,' '","value","value,label");
	$opts2 = new OptionsConnector($conn,"Postgre");	$opts2->render_sql("select id as value,name as label from department where id != -1 union select -1,' '","value","value,label");
	$opts3 = new OptionsConnector($conn,"Postgre"); $opts3->render_sql("select id as value,name as label from audit_type where id != -1 union select -1,' '","value","value,label");
	$opts4 = new OptionsConnector($conn,"Postgre"); $opts4->render_sql("select id as value,maintype as label from audit_type where id != -1 union select -1,' '","value","value,label");

	$config = new GridConfiguration();
	
	$config->setHeader(array("Institution","Department","Date","Title","Origine","Status","comment","Type","maintype"));
	$config->setColIds(array("inst_id","dep_id","date","title","origine","status_id","comment","audit_type","maintype"));
	$config->setColTypes(array("coro","coro","dhxCalendar","ro","coro","coro","ro","coro","coro"));
	$config->attachHeader(array("#rspan","#rspan","#daterange_filter","#rspan","#rspan","#connector_select_filter","#rspan","#rspan","#rspan"));
	$config->setColSorting(array("int","int","str","str","int","int","str","str","str"));
	$config->setInitWidths(array("*","*","*","*","*","120","*","140","*"));
	$config->setColHidden(array("0","0","0","0","0","0","1","0","1"));
	
	$data = new GridConnector($conn,"Postgre");

	$data->set_config($config);
	$data->set_options("status_id",$opts);
	$data->set_options("inst_id",$opts1);
	$data->set_options("dep_id",$opts2);
	$data->set_options("audit_type",$opts3);
	$data->set_options("maintype",$opts4);

	$arr_audit_value = array(AUDIT_INTERN_ID => $_CB_SelectAuditInterne,AUDIT_EXTERN_ID=> $_CB_SelectAuditExtern, AUDIT_AUTOEVAL_ID => $_CB_SelectAuditAutoEvaluation);

	$data->set_options("origine",$arr_audit_value);

	if($GLOBALS["active_debug"] === true)
	{
		$data->enable_log($GLOBALS["debug_dir"].basename(__FILE__).".log",true);
	}

	$data->event->attach('beforeInsert','my_insert');
	$data->event->attach('beforeUpdate','my_update');
	$data->event->attach('beforeDelete','my_delete');

	if(isset($_GET['auditid']))
	{
		$whereclause = $whereclause." and audit.id = {$_GET['auditid']}";
	}
	
	$data->render_complex_sql (
		"select audit.id, coalesce(inst_id,-1) as inst_id, coalesce(dep_id,-1) as dep_id, to_char(date,'DD/MM/YYYY') as date, origine, status_id, comment, title,audit.type as audit_type, maintype from audit,audit_type where audit.type=audit_type.id and audit.removed = false $whereclause",
		"id",
		"inst_id,dep_id,date,title,origine,status_id,comment,audit_type,maintype"
	);
}
