<?php
require_once('../../../../dhtmlx/phpconnector/grid_connector.php');
require_once('../../../../dhtmlx/phpconnector/grid_config.php');
require_once('../../../../dhtmlx/phpconnector/db_postgre.php');

require_once '../../autoload.php';

function my_insert($data){
  $conn = get_dbconnection();

  $sql = 'insert into device_inspection(device_id,result,status_id) values ('.$data->get_value('device_id').',-1,'.STATUS_PLANNED_ID.') returning id;';
  if ($query = pg_query($conn,$sql)){
     if(!($row = pg_fetch_row($query)))
     {
      $data->invalid();
      return;
     }
     $data->set_new_id($row[0]);
     $data->success(); // marks an operation as finished

  }else
  {
    $data->invalid();
  }
}


function my_update($data){

  $conn = get_dbconnection();
  $sql = 'update device_inspection';
  $sql .= ' set status_id = '.$data->get_value('status_id');
  $sql .= '  ,result = '.$data->get_value('result');

  if($data->get_value('inspection_date') != '')
    $sql .= ' ,inspection_date = to_timestamp(\''.pg_escape_string ($conn,$data->get_value('inspection_date')).'\',\'DD/MM/YYYY\')';
  else
    $sql .= ' ,inspection_date = null';

  if($data->get_value('planned_date') != '')
    $sql .= ' ,planned_date = to_timestamp(\''.pg_escape_string ($conn,$data->get_value('planned_date')).'\',\'DD/MM/YYYY\')';
  else
    $sql .= ' ,planned_date = null';

  $sql .= ' ,type = \''.pg_escape_string ($conn,$data->get_value('type')).'\'';
  $sql .= ' ,comment = \''.pg_escape_string ($conn,$data->get_value('comment')).'\'';
  $sql .= ' where id =  '.$data->get_id().';commit;';

  error_log ( $sql );
  
  if (!pg_query($conn,$sql)){
     $data->invalid();
  }else{
    $data->success(); // marks an operation as finished
  }
}

function my_delete($data){

  $sql = 'update device_inspection set removed = true where id = '.$data->get_id().';commit;';

  $conn = get_dbconnection();
  if (!pg_query($conn,$sql)){
     $data->invalid();
  }else
  {
    $data->success(); // marks an operation as finished
  }
}

$conn = get_dbconnection();

if($conn)
{
	$config = new GridConfiguration();
	$config->setHeader(array("device_id","status_id","result_id","Status","Planned","Performed","Result","Type","Comment","listofactiondescription"));
	$config->setColIds(array("device_id","status_id","result","status_name","planned_date","inspection_date","result_name","type","comment","listofactiondescription"));
	$config->setColTypes(array("ro","ro","ro","ro","dhxCalendar","dhxCalendar","ro","ro","ro","ro"));
	$config->attachHeader(array("#rspan","#rspan","#rspan","#rspan","#rspan","#rspan","#rspan","#rspan","#rspan","#rspan"));
	$config->setColSorting(array("int","int","int","str","str","str","str","str","str","str"));
	$config->setInitWidths(array("0","0","0","100","100","100","100","100","*","0"));
	$config->setColHidden(array("1","1","1","0","0","0","0","0","1"));
	$data = new GridConnector($conn,"Postgre");
	$data->set_config($config);

  if($GLOBALS["active_debug"] === true){
		$data->enable_log($GLOBALS["debug_dir"].basename(__FILE__).".log",true);
	}

  $data->event->attach('beforeInsert','my_insert');
  //
  $data->event->attach('beforeUpdate','my_update');
  //
  $data->event->attach('beforeDelete','my_delete');

  if(isset($_GET['deviceid']))
  {
     $whereclause = "and device_id = {$_GET['deviceid']}";
  }else {
    $whereclause = "and device_id = -1";
  }
	$data->render_complex_sql("select device_inspection.id as id,s2.status_name as result_name,s1.status_name as status_name,device_id,to_char(inspection_date,'DD/MM/YYYY') as inspection_date,to_char(planned_date,'DD/MM/YYYY') as planned_date,result,device_inspection.type as type,status_id,comment,listofactiondescription
from statuslist as s1, statuslist as s2,device_inspection left join (select ext_id,string_agg('&#x2022; '||description,'\n') as listofactiondescription from action,action_link where action.id = action_link.action_id and action_link.scope = 'device_inspection' group by ext_id) actionlink on actionlink.ext_id = device_inspection.id where s2.id = device_inspection.result and s1.id = device_inspection.status_id and device_inspection.removed = false {$whereclause}"
  ,"id"
  ,"device_id,status_id,result,status_name,planned_date,inspection_date,result_name,type,comment,listofactiondescription");
}
