<?php
require_once('../../../../dhtmlx/phpconnector/grid_connector.php');
require_once('../../../../dhtmlx/phpconnector/grid_config.php');
require_once('../../../../dhtmlx/phpconnector/db_postgre.php');

require_once '../../autoload.php';

function my_insert($data){
  $conn = get_dbconnection();

  $sql = 'insert into device_installation(device_id,installdate,dep_id) values ('.$data->get_value('device_id').',now(),-1) returning id;';
  if ($query = pg_query($conn,$sql)){
     if(!($row = pg_fetch_row($query)))
     {
      $data->invalid();
      return;
     }
     $data->set_new_id($row[0]);
     $data->success(); // marks an operation as finished

  }else
  {
    $data->invalid();
  }
}


function my_update($data){

  $conn = get_dbconnection();
  $sql = 'update device_installation';
  $sql .= ' set dep_id = '.$data->get_value('dep_id');

  $sql .= ' ,installdate = to_timestamp(\''.pg_escape_string ($conn,$data->get_value('installdate')).'\'||to_char(installdate,\'HH24MISS\'),\'DD/MM/YYYYHH24MISS\')';

  if($data->get_value('removeddate') != '')
    $sql .= ' ,removeddate = to_timestamp(\''.pg_escape_string ($conn,$data->get_value('removeddate')).'\'||to_char(now(),\'HH24MISS\'),\'DD/MM/YYYYHH24MISS\')';
  else
    $sql .= ' ,removeddate = null';

  $sql .= ' ,installedby = \''.pg_escape_string ($conn,$data->get_value('installedby')).'\'';
  $sql .= ' ,inchargeof = \''.pg_escape_string ($conn,$data->get_value('inchargeof')).'\'';
  $sql .= ' ,comment = \''.pg_escape_string ($conn,$data->get_value('comment')).'\'';
  $sql .= ' where id =  '.$data->get_id().';commit;';
  error_log($sql);
  if (!pg_query($conn,$sql)){
     $data->invalid();
  }else
    $data->success(); // marks an operation as finished
}

function my_delete($data){

  $sql = 'update device_installation set removed = true where id = '.$data->get_id().';commit;';

  $conn = get_dbconnection();
  if (!pg_query($conn,$sql)){
     $data->invalid();
  }else
  {
    $data->success(); // marks an operation as finished
  }
}

$conn = get_dbconnection();

if($conn)
{

	$config = new GridConfiguration();
	$config->setHeader(array("device_id","dep_id","Department","From","Until","Installed by","comment","inchargeof"));
	$config->setColIds(array("device_id","dep_id","fullname","installdate","removeddate","installedby","comment","inchargeof"));
	$config->setColTypes(array("ro","ro","ro","dhxCalendar","dhxCalendar","ro","ro","ro"));
	$config->attachHeader(array("#rspan","#rspan","#rspan","#rspan","#rspan","#rspan","#rspan","#rspan"));
	$config->setColSorting(array("int","int","str","str","str","str","str","str"));
	$config->setInitWidths(array("0","0","*","*","100","100","100","100"));
	$config->setColHidden(array("1","1","0","0","0","0","1","1"));
	$data = new GridConnector($conn,"Postgre");
	$data->set_config($config);


  if($GLOBALS["active_debug"] === true){
		$data->enable_log($GLOBALS["debug_dir"].basename(__FILE__).".log",true);
	}

  $data->event->attach('beforeInsert','my_insert');
  //
  $data->event->attach('beforeUpdate','my_update');
  //
  $data->event->attach('beforeDelete','my_delete');

  if(isset($_GET['deviceid']))
  {
     $whereclause = "and device_id = {$_GET['deviceid']}";
  }else {
    $whereclause = "and device_id = -1";
  }
	$data->render_complex_sql("select device_installation.device_id as device_id,device_installation.id as id,v_fullinfo_department.fullname as fullname,device_installation.dep_id as dep_id,to_char(installdate,'DD/MM/YYYY') as installdate,to_char(removeddate,'DD/MM/YYYY') as removeddate,installedby,comment,inchargeof from device_installation,v_fullinfo_department
  where v_fullinfo_department.dep_id = device_installation.dep_id and device_installation.removed = false {$whereclause}"
  ,"id"
  ,"device_id,dep_id,fullname,installdate,removeddate,installedby,comment,inchargeof");
}
