<?php
require_once('../../../../dhtmlx/phpconnector/grid_connector.php');
require_once('../../../../dhtmlx/phpconnector/grid_config.php');
require_once('../../../../dhtmlx/phpconnector/db_postgre.php');

require_once '../../autoload.php';

function my_insert($data){
  $conn = get_dbconnection();
  $sql = 'insert into examlist(nameid) values (\'New exam\') returning id;';

  if ($query = pg_query($conn,$sql)){
     if(!($row = pg_fetch_row($query)))
     {
      $data->invalid();
      return;
     }
     $data->set_new_id($row[0]);
     $data->success(); // marks an operation as finished

  }else
  {
    $data->invalid();
  }
}


function my_update($data)
{
	$conn = get_dbconnection();

  $sql = 'update examlist';
  $sql .= ' set nameid = \''.pg_escape_string ($conn,$data->get_value('nameid')).'\'';
  $sql .= ' ,modality = \''.pg_escape_string ($conn,$data->get_value('modality')).'\'';
  $sql .= ' ,description = \''.pg_escape_string ($conn,$data->get_value('description')).'\'';
  $sql .= ' where id =  '.$data->get_id().';';

  if($data->get_value('warninglist') == '')
  {
    $sql .= 'delete from examwarning_link where exam_id = '.$data->get_id().';commit;';
  }
	else
	{
    $sql .= 'delete from examwarning_link where exam_id = '.$data->get_id().' and examwarning_id not in ('.$data->get_value('warninglist').');';
    $sql .= 'insert into examwarning_link(exam_id,examwarning_id)
      select '.$data->get_id().', examwarning.id from examwarning left join examwarning_link on examwarning_link.examwarning_id = examwarning.id and exam_id = '.$data->get_id().'
      where  examwarning.id in ('.$data->get_value('warninglist').') and examwarning.removed = false and examwarning_link.examwarning_id is null;commit;';
  }
  
  if($data->get_value('tagexamlist') == '')
  {
    $sql .= 'delete from tag_link where type = \'examlist\' and ext_id = '.$data->get_id().';commit;';
  }
	else
	{
    $sql .= 'delete from tag_link where type = \'examlist\' and ext_id = '.$data->get_id().' and tag_id not in ('.$data->get_value('tagexamlist').');';
    $sql .= 'insert into tag_link(type,ext_id,tag_id)
      select \'examlist\','.$data->get_id().', tag.id from tag left join tag_link on tag_link.tag_id = tag.id and tag_link.type =  \'examlist\' and  tag_link.ext_id = '.$data->get_id().'
      where  tag.id in ('.$data->get_value('tagexamlist').') and tag.removed = false and tag_link.ext_id is null;commit;';
  }

	if (!pg_query($conn,$sql))
	{
     $data->invalid();
	}
	else
	{
    $data->success(); // marks an operation as finished
	}
}

function my_delete($data){

  $sql = 'update examlist set removed = true where id = '.$data->get_id().';commit;';

  $conn = get_dbconnection();
  if (!pg_query($conn,$sql)){
     $data->invalid();
  }else
  {
    $data->success(); // marks an operation as finished
  }
}

$conn = get_dbconnection();

if($conn)
{

	$config = new GridConfiguration();
	$config->setHeader(array("Name","Modality","description","riskv","taglist"));
	$config->setColIds(array("nameid","modality","description","riskv","taglist"));
	$config->setColTypes(array("ro","ro","ro","ro","ro"));
	$config->attachHeader(array("#rspan","#rspan","#rspan","#rspan","#rspan"));
	$config->setColSorting(array("str","str","str","str","str"));
	$config->setInitWidths(array("*","120","0","0","0"));
	$config->setColHidden(array("0","0","1","1","1"));
	$data = new GridConnector($conn,"Postgre");
	$data->set_config($config);


  if($GLOBALS["active_debug"] === true){
		$data->enable_log($GLOBALS["debug_dir"].basename(__FILE__).".log",true);
	}

  $data->event->attach('beforeInsert','my_insert');

  $data->event->attach('beforeUpdate','my_update');

  $data->event->attach('beforeDelete','my_delete');

  $whereclause = '';
  if(isset($_GET['examid']))
  {
     $whereclause = "and examlist.id = {$_GET['examid']}";
  }
  $select = "select examlist.id,modality,nameid,description,STRING_AGG (examwarning_link.examwarning_id::text,',') as riskv,f_tag_link(examlist.id) as taglist from examlist left join examwarning_link on examwarning_link.exam_id = examlist.id
  where examlist.removed = false $whereclause and (examwarning_link.examwarning_id is null or examwarning_link.examwarning_id is not null) group by examlist.id,nameid,description";
  //if examid is set no tag filter
  if(!isset($_GET['examid']) && isset($_GET['taglist']) && $_GET['taglist'] != '')
  {
    $tagcondition = '';
    $conn2 = get_dbconnection();
  
    //$tagselect = "select string_agg('tag_link.tag_id = ' || id::varchar,' '||type||' ') from tag where id in ({$_GET['taglist']}) group by type;";
    $tagselect = "select 'ARRAY['||string_agg(id::varchar,',')||']',type from tag where removed = false and id in ({$_GET['taglist']}) group by type";

    if ($query = pg_query($conn2,$tagselect))
    {
       if($row = pg_fetch_row($query))
       {
         $tagcondition = "(string_to_array(taglist,',')::int[] ".(($row[1] == 'AND')? '@>' : '&&')." ".$row[0].")";
         while($row = pg_fetch_row($query))
         {
           $tagcondition .= " and (string_to_array(taglist,',')::int[] ".(($row[1] == 'AND')? '@>' : '&&')." ".$row[0].")";
         }
         $select = "select id,modality,nameid,description,riskv,taglist from (select examlist.id,modality,nameid,description,STRING_AGG (examwarning_link.examwarning_id::text,',') as riskv,f_tag_link(examlist.id) as taglist from examlist left join examwarning_link on examwarning_link.exam_id = examlist.id
         where examlist.removed = false and (examwarning_link.examwarning_id is null or examwarning_link.examwarning_id is not null) group by examlist.id,nameid,description) as allexam where $tagcondition";
         error_log($select);
       }
    }
  }

  $data->render_complex_sql($select,"id","nameid,modality,description,riskv,taglist");


}
