<?php
require_once('../../../../dhtmlx/phpconnector/grid_connector.php');
require_once('../../../../dhtmlx/phpconnector/grid_config.php');
require_once('../../../../dhtmlx/phpconnector/db_postgre.php');

require_once '../../autoload.php';



$conn = get_dbconnection();

if($conn)
{

	$config = new GridConfiguration();
	
	$config->setHeader		( array ( "Name",	"Modality",	"description",	"riskv",	"taglist",	"doc_id",	"doc_otherdoc_id"	));
	$config->setColIds		( array ( "nameid",	"modality",	"description",	"riskv",	"taglist",	"doc_id",	"doc_otherdoc_id"	));
	$config->setColTypes	( array ( "ro",		"ro",		"ro",			"ro",		"ro",		"ro",		"ro"				));
	$config->attachHeader	( array ( "#rspan",	"#rspan",	"#rspan",		"#rspan",	"#rspan",	"#rspan",	"#rspan"			));
	$config->setColSorting	( array ( "str",	"str",		"str",			"str",		"str",		"int",		"int"				));
	$config->setInitWidths	( array ( "*",		"120",		"0",			"0",		"0",		"50",		"50"				));
	$config->setColHidden	( array ( "0",		"0",		"1",			"1",		"1",		"1",		"1"					));
	
	$data = new GridConnector($conn,"Postgre");
	$data->set_config($config);


  if($GLOBALS["active_debug"] === true){
		$data->enable_log($GLOBALS["debug_dir"].basename(__FILE__).".log",true);
	}


  $whereclause = '';
  if(isset($_GET['examid']))
  {
     $whereclause = "and examlist.id = {$_GET['examid']}";
  }
  $select = "select id,modality,nameid,description,riskv,taglist,doc_id,doc_otherdoc_id from (select examlist.id,modality,nameid,description,STRING_AGG (examwarning_link.examwarning_id::text,',') as riskv,f_tag_link(examlist.id) as taglist from examlist left join examwarning_link on examwarning_link.exam_id = examlist.id
			where examlist.removed = false and (examwarning_link.examwarning_id is null or examwarning_link.examwarning_id is not null) group by examlist.id,nameid,description) as allexam
			left join (select document_link.doc_id, document_link.ext_id from v_last_documentstatus, document_link where v_last_documentstatus.status_id = 1 and v_last_documentstatus.doc_id = document_link.doc_id and document_link.type = 'examlist') as allexamwithdoc on allexamwithdoc.ext_id = allexam.id 
			left join (select document_link.doc_id as doc_otherdoc_id, document_link.ext_id from v_last_documentstatus, document_link where v_last_documentstatus.status_id = 1 and v_last_documentstatus.doc_id = document_link.doc_id and document_link.type = 'examlist_otherdocument') as allexamwithotherdoc on allexamwithotherdoc.ext_id = allexam.id";;
  
	//if examid is set no tag filter
	if ( isset($_GET['taglist']) && $_GET['taglist'] != '' )
	{
		$tagcondition 	= '';
		$conn2 			= get_dbconnection();

		$tagselect = "select 'ARRAY['||string_agg(id::varchar,',')||']',type from tag where removed = false and id in ({$_GET['taglist']}) group by type";

		if ($query = pg_query($conn2,$tagselect))
		{
			if($row = pg_fetch_row($query))
			{
				$tagcondition = "(string_to_array(taglist,',')::int[] ".(($row[1] == 'AND')? '@>' : '&&')." ".$row[0].")";
				while ( $row = pg_fetch_row($query) )
				{
					$tagcondition .= " and (string_to_array(taglist,',')::int[] ".(($row[1] == 'AND')? '@>' : '&&')." ".$row[0].")";
				}
				
				$select = "select id,modality,nameid,description,riskv,taglist,doc_id, doc_otherdoc_id from (select examlist.id,modality,nameid,description,STRING_AGG (examwarning_link.examwarning_id::text,',') as riskv,f_tag_link(examlist.id) as taglist from examlist left join examwarning_link on examwarning_link.exam_id = examlist.id
							where examlist.removed = false and (examwarning_link.examwarning_id is null or examwarning_link.examwarning_id is not null) group by examlist.id,nameid,description) as allexam 
							left join (select document_link.doc_id, document_link.ext_id from v_last_documentstatus, document_link where v_last_documentstatus.status_id = 1 and v_last_documentstatus.doc_id = document_link.doc_id and document_link.type = 'examlist') as allexamwithdoc on allexamwithdoc.ext_id = allexam.id 
							left join (select document_link.doc_id as doc_otherdoc_id, document_link.ext_id from v_last_documentstatus, document_link where v_last_documentstatus.status_id = 1 and v_last_documentstatus.doc_id = document_link.doc_id and document_link.type = 'examlist_otherdocument') as allexamwithotherdoc on allexamwithotherdoc.ext_id = allexam.id where $tagcondition";
			}
		}
	}	

	// error_log ( " SQL : ".$select );
	$data->render_complex_sql 
	( 
		$select,
		"id",
		"nameid,modality,description,riskv,taglist,doc_id, doc_otherdoc_id"
	);
}
