<?php
require_once('../../../../dhtmlx/phpconnector/grid_connector.php');
require_once('../../../../dhtmlx/phpconnector/grid_config.php');
require_once('../../../../dhtmlx/phpconnector/db_postgre.php');

require_once '../../autoload.php';

function my_insert($data){
  $conn = get_dbconnection();
  $sql = 'insert into legaldocument(name) values (\'New\') returning id;';

  if ($query = pg_query($conn,$sql)){
     if(!($row = pg_fetch_row($query)))
     {
      $data->invalid();
      return;
     }
     $data->set_new_id($row[0]);
     $data->success(); // marks an operation as finished

  }else
  {
    $data->invalid();
  }
}


function my_update($data){

  $conn = get_dbconnection();
  $sql = 'update legaldocument';
  $sql .= ' set name = \''.pg_escape_string ($conn,$data->get_value('name')).'\'';
  $sql .= ' ,type = \''.pg_escape_string ($conn,$data->get_value('type')).'\'';
  $sql .= ' ,comment = \''.pg_escape_string ($conn,$data->get_value('comment')).'\'';
  $sql .= ' where id =  '.$data->get_id().';commit;';

  if (!pg_query($conn,$sql)){
     $data->invalid();
  }else
    $data->success(); // marks an operation as finished
}

function my_delete($data){

  $sql = 'update legaldocument set removed = true where id = '.$data->get_id().';commit;';

  $conn = get_dbconnection();
  if (!pg_query($conn,$sql)){
     $data->invalid();
  }else
  {
    $data->success(); // marks an operation as finished
  }
}

$conn = get_dbconnection();

if($conn)
{

	$config = new GridConfiguration();
	$config->setHeader		( array ( "Name","Type","Comment", "doc_id") );
	$config->setColIds		( array ( "name","type","comment", "doc_id") );
	$config->setColTypes	( array ( "ro","ro","ro", "ro") );
	$config->attachHeader	( array ( "#text_filter","#text_filter","#rspan"));
	$config->setColSorting	( array ( "str","str","str", "str"));
	$config->setInitWidths	( array ( "*","100","*", "*"));
	$config->setColHidden	( array ( "0","0","0", "1"));
	$data = new GridConnector($conn,"Postgre");
	$data->set_config($config);

  if($GLOBALS["active_debug"] === true){
		$data->enable_log($GLOBALS["debug_dir"].basename(__FILE__).".log",true);
	}

  $data->event->attach('beforeInsert','my_insert');

  $data->event->attach('beforeUpdate','my_update');

  $data->event->attach('beforeDelete','my_delete');

  $whereclause = '';
  if(isset($_GET['legaldocumentid']))
  {
     $whereclause = "and legaldocument.id = {$_GET['legaldocumentid']}";
  }
	// $data->render_complex_sql("select id,name,type, comment from legaldocument where removed = false $whereclause order by name,type","id","name,type,comment");
	// $data->render_complex_sql ( "select name, legaldocument.type, comment, doc_id from legaldocument,document_link where legaldocument.id=document_link.ext_id and document_link.type='legaldocument' and removed = false $whereclause order by name,type","id","name,type,comment");
	
	$select = "select name, legaldocument.type, comment, doc_id from legaldocument,document_link where legaldocument.id=document_link.ext_id and document_link.type='legaldocument' and removed = false $whereclause order by name,type";
	
	$data->render_complex_sql ( $select,"id","name,type,comment,doc_id");
}
