<?php
require_once('../../../../dhtmlx/phpconnector/grid_connector.php');
require_once('../../../../dhtmlx/phpconnector/grid_config.php');
require_once('../../../../dhtmlx/phpconnector/db_postgre.php');

require_once '../../autoload.php';

$whereclause = '';
if(isset($_GET["dhx_filter"])){
  foreach($_GET["dhx_filter"] as $k => $v)
  {
    if($v != ''){
      switch($k)
      {
        case 1:
			{
				$ldate = explode("|", $v);

				if($ldate[0] != '')
				{
					$whereclause .= " and action.begdate >= to_timestamp('{$ldate[0]} 00:00:00','DD/MM/YYYY HH24:MI:SS')";
				}

				if($ldate[1] != '')
				{
					$whereclause .= " and action.begdate <= to_timestamp('{$ldate[1]} 23:59:59' ,'DD/MM/YYYY HH24:MI:SS')";
				}
			}
			break;

		case 4:
			{
				$whereclause .= " and action.status_id = {$v}";
			}
			break;

		default:;
      }
    }
  }
}

function my_insert($data){
  $conn = get_dbconnection();
  $sql = 'insert into action(description,begdate,status_id) values (\'New task\',now(),'.STATUS_PLANNED_ID.') returning id;';

  if ($query = pg_query($conn,$sql)){
     if(!($row = pg_fetch_row($query)))
     {
      $data->invalid();
      return;
     }
     $data->set_new_id($row[0]);
     $data->success(); // marks an operation as finished
  }else
  {
    $data->invalid();
  }
}


function my_update ( $data )
{
	$conn = get_dbconnection();

	$sql = 'update action';
	$sql .= ' set status_id = '.$data->get_value('status_id');
	$sql .= ' ,description = \''.pg_escape_string ($conn,$data->get_value('description')).'\'';
	$sql .= ' ,origine = \''.pg_escape_string ($conn,$data->get_value('origine')).'\'';

	if('' != $data->get_value('personincharge') && $data->get_value('personincharge') != '-1')
		$sql .= ' ,personincharge = '.$data->get_value('personincharge');
	else
		$sql .= ' ,personincharge = null';

	if ( $data->get_value('closeddate') != '')
		$sql .= ' ,enddate = to_timestamp(\''.pg_escape_string ($conn,$data->get_value('closeddate')).'\',\'DD/MM/YYYY\')';
	else
		$sql .= ' ,enddate = null';

	if ( $data->get_value('deadline') != '')
		$sql .= ' ,deadline = to_timestamp(\''.pg_escape_string ($conn,$data->get_value('deadline')).'\',\'DD/MM/YYYY\')';
	else
		$sql .= ' ,deadline = null';

	if ( $data->get_value('begdate') != '')
		$sql .= ' ,begdate = to_timestamp(\''.pg_escape_string ($conn,$data->get_value('begdate')).'\',\'DD/MM/YYYY\')';

	$sql .= ' where id =  '.$data->get_id().';commit;';

	error_log($sql);

	if (!pg_query($conn,$sql))
	{
		$data->invalid();
	}
	else
		$data->success(); // marks an operation as finished
}

function my_delete ( $data )
{
	$sql = 'update action set removed = true where id = '.$data->get_id().';commit;';

	$conn = get_dbconnection();
	if (!pg_query($conn,$sql)){
		$data->invalid();
	}
	else
	{
		$data->success(); // marks an operation as finished
	}
}

$conn = get_dbconnection();

if (  $conn )
{
	$opts = new OptionsConnector($conn,"Postgre");
	$opts->render_sql("select id as value,status_name as label from statuslist where type ilike '%|action|%'","value","value,label");

	$config = new GridConfiguration();

	$config->setHeader		( array ( "personincharge","",	"Created",			"Source",	"Description",	"Status",					"deadline",		"closeddate","actionlinkid"	));
	$config->setColIds		( array ( "personincharge","shortcut_pin",	"begdate",			"origine",	"description",	"status_id",				"deadline","closeddate","actionlinkid"	));
	$config->setColTypes	( array ( "ro","icon",				"dhxCalendar",		"ro",		"ro",			"coro",						"dhxCalendar",	"dhxCalendar","ro"));
	$config->attachHeader	( array ( "#rspan","#rspan",			"#daterange_filter","#rspan",	"#rspan",		"#connector_select_filter",	"#rspan",		"#rspan","#rspan"	));
	$config->setColSorting	( array ( "int","na",			"str",				"str",		"str",			"str",						"str",			"str","str"));
	$config->setInitWidths	( array ("0", "30",				"80",				"100",		"*",			"100",						"0",			"0", "0"));

  if(isset($_GET['forselection']) && $_GET['forselection']=='1'){
    $config->setColHidden	( array ( "1","0",				"0",				"0",		"0",			"0",						"1",			"1","1"));
  }
  else{
    $config->setColHidden	( array ( "1","1",				"0",				"0",		"0",			"0",						"1",			"1","1"));
  }

	$data = new GridConnector($conn,"Postgre");
	$data->set_config($config);
	$data->set_options("status_id",$opts);

	if ( $GLOBALS["active_debug"] === true)
	{
		$data->enable_log($GLOBALS["debug_dir"].basename(__FILE__).".log",true);
	}

	$data->event->attach('beforeInsert','my_insert');

	$data->event->attach('beforeUpdate','my_update');

	$data->event->attach('beforeDelete','my_delete');

	if(isset($_GET['actionid']))
	{
		$whereclause = " and action.id = {$_GET['actionid']}";
	}

  $listofactionid = '-1';

  if(isset($_GET['scope']) && $_GET['listofactionid'] != '' )
  {
    $listofactionid .= ','.$_GET['listofactionid'];
  }
  $databind = 'personincharge,shortcut_pin,begdate,origine,description,status_id,deadline,closeddate,actionlinkid';

  $datasql = "select action.id as id, '".ICON_PIN_FONT."' as shortcut_pin,description,coalesce(action.personincharge,-1) as personincharge, to_char(begdate,'DD/MM/YYYY') as begdate,status_id,origine,to_char(deadline,'DD/MM/YYYY') as deadline
  , to_char(enddate,'DD/MM/YYYY') as closeddate, '' as actionlinkid
	from action left join staff_member on (action.personincharge = staff_member.id)  where action.removed = false $whereclause";


  if(isset($_GET['forselection']) && $_GET['forselection']=='1'){
    $datasql = "select action.id as id, case when action_link.id is null then '".ICON_PIN_FONT."' else '".ICON_UNPIN_FONT."' end as shortcut_pin,description,coalesce(action.personincharge,-1) as personincharge, to_char(begdate,'DD/MM/YYYY') as begdate,status_id,origine,to_char(deadline,'DD/MM/YYYY') as deadline
    , to_char(enddate,'DD/MM/YYYY') as closeddate, action_link.id as actionlinkid
    from action left join staff_member on (action.personincharge = staff_member.id) left join action_link on action_link.scope = '{$_GET['scope']}' and action.id = action_link.action_id and action_link.ext_id = {$_GET['scopeid']}   where action.removed = false {$whereclause}";
  }

  $data->render_complex_sql ($datasql, "id", $databind);
}
