<?php
require_once('../../../../dhtmlx/phpconnector/grid_connector.php');
require_once('../../../../dhtmlx/phpconnector/grid_config.php');
require_once('../../../../dhtmlx/phpconnector/db_postgre.php');

require_once '../../autoload.php';

function my_insert ( $data )
{
  $conn = get_dbconnection();
  $sql = 'insert into examwarning(title,sex_id,age_id) values (\''.pg_escape_string ($conn,$data->get_value('title')).'\',2,3) returning id;';

  if ($query = pg_query($conn,$sql)){
     if(!($row = pg_fetch_row($query)))
     {
      $data->invalid();
      return;
     }

     $data->set_new_id($row[0]);
     $data->success(); // marks an operation as finished

  }else
  {
    $data->invalid();
  }
}

function my_update ( $data )
{
  $conn = get_dbconnection();
  
  $sql = 'update examwarning set title = \''.pg_escape_string ($conn,$data->get_value('title')).'\'';
  $sql .= ', description = \''.pg_escape_string($conn,$data->get_value('description'));
  $sql .= '\', sex_id = '.$data->get_value('sex_id');
  $sql .= ', age_id = '.$data->get_value('age_id');
  $sql .=' where id = '.$data->get_id().';';

  error_log ( $sql );
  
  if (!pg_query($conn,$sql))
  {
     $data->invalid();
  }else
  {
    $data->success(); // marks an operation as finished
  }
}


function my_delete($data){

  $sql = 'update examwarning set removed = true where id = '.$data->get_id().';commit;';

  $conn = get_dbconnection();
  if (!pg_query($conn,$sql)){
     $data->invalid();
  }else
  {
    $data->success(); // marks an operation as finished
  }
}

$conn = get_dbconnection();

if($conn)
{
	$config = new GridConfiguration();
	
	$config->setHeader		( array ( "Title",	"Description", 	"sex_id",	"age_id"	));
	$config->setColIds		( array ( "title",	"description", 	"sex_id",	"age_id"	));
	$config->setColTypes	( array ( "ro",		"ro",			"ro",		"ro"		));
	$config->attachHeader	( array ( "#rspan",	"#rspan",		"#rspan",	"#rspan"		));
	$config->setColSorting	( array ( "str",	"str",			"str",		"str"		));
	$config->setInitWidths	( array ( "200",	"*",			"*",		"*"			));
	$config->setColHidden	( array ( "0",		"0",			"1",		"1"			));
	
	$data = new GridConnector($conn,"Postgre");
	$data->set_config($config);


    $data->event->attach('beforeInsert','my_insert');
	$data->event->attach('beforeUpdate','my_update');
	$data->event->attach('beforeDelete','my_delete');
	
	$data->render_sql("select id,title,description,sex_id,age_id from examwarning where removed = false","id","title,description,sex_id,age_id");
}
