<?php
require_once('../../../../dhtmlx/phpconnector/grid_connector.php');
require_once('../../../../dhtmlx/phpconnector/grid_config.php');
require_once('../../../../dhtmlx/phpconnector/db_postgre.php');

require_once '../../autoload.php';

function my_insert($data){
  $conn = get_dbconnection();
  $sql = 'insert into login_role(name) values (\''.pg_escape_string ($conn,$data->get_value('name')).'\') returning id;';

  if ($query = pg_query($conn,$sql)){
     if(!($row = pg_fetch_row($query)))
     {
      $data->invalid();
      return;
     }

     $data->set_new_id($row[0]);
     $data->success(); // marks an operation as finished

  }else
  {
    $data->invalid();
  }
}


function my_delete($data){

  $sql = 'update login_role set removed = true where id = '.$data->get_id().';commit;';

  $conn = get_dbconnection();
  if (!pg_query($conn,$sql)){
     $data->invalid();
  }else
  {
    $data->success(); // marks an operation as finished
  }
}

$conn = get_dbconnection();

if($conn)
{

	$config = new GridConfiguration();
	$config->setHeader(array("Role"));
	$config->setColIds(array("name"));
	$config->setColTypes(array("ro"));
	$config->attachHeader(array("#rspan"));
	$config->setColSorting(array("str"));
	$config->setInitWidthsP(array("100"));
	$config->setColHidden(array("0"));
	$data = new GridConnector($conn,"Postgre");
	$data->set_config($config);


  if($GLOBALS["active_debug"] === true){
		$data->enable_log($GLOBALS["debug_dir"].basename(__FILE__).".log",true);
	}
  $data->event->attach('beforeInsert','my_insert');
  $data->event->attach('beforeDelete','my_delete');

	$data->render_sql("select id,name from login_role where removed = false and name != 'admin'","id","name");
}
