<?php
require_once('../../../../dhtmlx/phpconnector/grid_connector.php');
require_once('../../../../dhtmlx/phpconnector/grid_config.php');
require_once('../../../../dhtmlx/phpconnector/db_postgre.php');

require_once '../../autoload.php';

$conn = get_dbconnection();

if($conn)
{

	$config = new GridConfiguration();
	$config->setHeader(array("Institution","Department","Role","Start date","End date","staff_id","staff_role_id","dep_id"));
	$config->setColIds(array("institution","department","rolename","begdate","enddate","staff_id","staff_role_id","dep_id"));
	$config->setColTypes(array("ro","ro","ro","dhxCalendar","dhxCalendar","ro","ro","ro"));
	$config->attachHeader(array("#rspan","#rspan","#rspan","#rspan","#rspan","#rspan","#rspan","#rspan"));
	$config->setColSorting(array("str","str","str","str","str","str","str","str"));
	$config->setInitWidths(array("*","*","100","80","80","40","40","40"));
	$config->setColHidden(array("0","0","0","0","0","1","1","1"));
	$data = new GridConnector($conn,"Postgre");
	$data->set_config($config);


  if($GLOBALS["active_debug"] === true){
		$data->enable_log($GLOBALS["debug_dir"].basename(__FILE__).".log",true);
	}

	$sqlreq = "select staff_job.id as id ,institution.name as institutionname,department.name as departmentname,staff_role.name as rolename,to_char(staff_job.begdate,'DD/MM/YYYY') as begdate,to_char(staff_job.enddate,'DD/MM/YYYY') as enddate, staff_member.id as staff_id,staff_job.staff_role_id, staff_job.dep_id as dep_id
		from institution,department,staff_member, staff_job, staff_role
		where staff_role.id = staff_job.staff_role_id and institution.id = department.inst_id and department.id= staff_job.dep_id and staff_member.id = staff_job.staff_id and staff_job.removed =false";

	if(!isset($_GET['jobid']))
	{

		$sqlreq.= " and staff_member.id = {$_GET['staffid']}";

	}else {

		$sqlreq.= " and staff_job.id = {$_GET['jobid']}";

	}

	$data->render_sql($sqlreq,"id","institutionname,departmentname,rolename,begdate,enddate,staff_id,staff_role_id,dep_id");
}
