<?php

  include './autoload.php';

  function ColorAlert ( $tab )
  {
		$level = 4;

		$conn = get_dbconnection();

		switch ( $tab )
		{
			default							:	$level = -1;																							break;
			case VIEW_AUDIT  				:	$level = 0;		$sql = "select level from v_alert_audit order by level desc limit 1";					break;
			case VIEW_DEVICE 				:	$level = 0;		$sql = "select level from v_alert_device_inspection order by level desc limit 1";		break;
			case VIEW_STAFF  				:	$level = 0;		$sql = "select level from v_alert_staff_formation order by level desc limit 1";			break;
			case VIEW_DOSIMETRY				:	$level = 0;		$sql = "select level from v_alert_afcnsend order by level desc limit 1";				break;
			case VIEW_INCIDENTREPORTING		:	$level = 0;		$sql = "select severity from v_alert_report order by severity desc limit 1";			break;
			case VIEW_SCHEDULEDTASK			:	$level = 0;		$sql = "select level from v_alert_action order by level desc limit 1";					break;
		}

		if ( empty ( $sql ) == FALSE)
		{
			if ( $query = pg_query($conn,$sql) )
			{
				while ( $row = pg_fetch_row($query) )
				{
					$level = $row[0];
				}
			}
		}

		switch ( $level )
		{
			case 0:		$ret = "AlertTab0";			break;
			case 1:		$ret = "AlertTab1";			break;
			case 2:		$ret = "AlertTab2";			break;
			case 3:		$ret = "AlertTab3";			break;
			case -1:	$ret = "AlertTabNone";		break;
		}

		return $ret;
  }

 ?>
<!DOCTYPE html>
<html lang="en">

<head>

  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <meta name="description" content="">
  <meta name="author" content="">
  <link rel="stylesheet" type="text/css" href="/dhtmlx/codebase/fonts/font_roboto/roboto.css"/>
  <link rel="stylesheet" type="text/css" href="/dhtmlx/codebase/dhtmlx.css"/>
  <link rel="stylesheet" type="text/css" href="/dhtmlx/skins/web/dhtmlx.css"/>
  <link rel="stylesheet" type="text/css" href="/extern_css/bootstrap-4.5.3/css/bootstrap.min.css"/>
  <link rel="shortcut icon" type="image/x-icon" href="../Common/pics/eoqual.png" />
  <script type='text/javascript' src="/dhtmlx/codebase/dhtmlx.js"></script>
  <script type='text/javascript' src="/dhtmlx_addon/dhtmlxgrid_doublecalendarinput.js"></script>
  <script type='text/javascript' src="/dhtmlx_addon/dhtmlxgrid_searchcbfilter.js"></script>
  <link rel="stylesheet" href="/extern_css/checkbox/searchableOptionList.css">
  <script type="text/javascript" src="js/jquery/jquery.js"></script>
  <script type="text/javascript" src="/extern_css/checkbox/sol.js"></script>
	<script type='text/javascript' src="/dhtmlx_addon/dhtmlxform_buttonximeo.js"></script>
  <script type='text/javascript' src="/dhtmlx_addon/c_dhtmlxutils.js"></script>
  <script src="js/c_documentmanager.js"></script>
  <script src="js/c_filemanager.js"></script>

  <script src="js/statistic_color.js"> </script>




  <link rel="stylesheet" href="css/eoQUAL.css"/>
  <!-- Custom fonts for this template-->
  <link href="/extern_css/font-awesome-current/css/all.min.css" rel="stylesheet" type="text/css">

  <!-- Core plugin JavaScript-->
  <script src="js/jquery-easing/jquery.easing.min.js"></script>
  <!-- Custom styles for this template-->
  <link href="css/sb-admin.css" rel="stylesheet">

  <style>

  /*fix bug with bootstrap (grid resize after research)*/
  *, *::before, *::after {
    box-sizing: content-box;
  }


	div.AlertTab0,  div.AlertTab1, div.AlertTab2, div.AlertTab3, div.AlertTabNone
	{
		display: block;
		width: 10px;
		height: auto;
	}

	div.AlertTab0	{	background-color: #b4ffba;	}
	div.AlertTab1	{	background-color: #c1dcff;	}
	div.AlertTab2	{	background-color: #fff3a0;	}
	div.AlertTab3	{	background-color: #faa7aa;	}

	div.TextTab
	{
		color: #ff757d;
		flex: 1;
		padding: 0.0rem 0rem;
		background-color: transparent;
	}

	.row1
	{
		display: flex;
		width: auto;
		border: 1px solid;
	}
  </style>

  <title>eoQUAL</title>

  <script>
    var myLayout = null;
    var embeddedpage = true;
    <?php create_translate_xml_js_function(); ?>

    function RenderPage ( url )
	{
    	var http;

    	if ( window.XMLHttpRequest )
		{
    		try { http = new XMLHttpRequest(); }
    		catch(e) {}
    	}
    	else
		{
			if (window.ActiveXObject)
			{
				try { http = new ActiveXObject("Msxml2.XMLHTTP"); }
				catch(e)
				{
    			    try { http = new ActiveXObject("Microsoft.XMLHTTP");  }
    			        catch(e) {}
				}
			}
		}

		if ( ! http )
		{
			alert('\n\nSorry, unable to open a connection to the server.');

			return false;
		}

		var target = document.querySelector('#page_content');

		// create an observer instance
		var observer = new MutationObserver
		( 	function ( mutations )
			{
				mutations.forEach
				(
					function ( mutation )
					{
						// later, you can stop observing
						// observer.disconnect();
						// var newElement = document.getElementById("page_content");
						// myLayout = null;
						// var scripts = newElement.getElementsByTagName("script");
						//   for (var i = 0; i < scripts.length; ++i) {
						//     var script = scripts[i];
						//     eval(script.innerHTML);
						//   }
					}
				);
			}
		);

		// configuration of the observer:
		//  var config = {childList: true };

		// pass in the target node, as well as the observer options
		//    observer.observe(target, config);

    http.onreadystatechange = function(){
      if (http.readyState == 4) {
        if(http.status == 200) {
          if(http.responseText)
          {
            if(myLayout != null)
            {
              myLayout.unload();
            }
            myLayout = null;
            window.myLayout = null;
            var node = document.getElementById("page_content");
            var last;
            while (last = node.lastChild) node.removeChild(last);
            node.innerHTML = http.responseText;
            var scripts = node.getElementsByTagName("script");

            for (var i = 0; i < scripts.length; ++i) {
             var script = scripts[i];
             eval(script.innerHTML);
            }
           dispatchEvent(new Event('load'));
           myLayout = window.myLayout;
           dispatchEvent(new Event('resize'));
         }
        }
      }
    };
    http.open('GET',url,true);

    http.send(null);

  }




    function init_page ()
	{
		<?php if(!isset($_GET['pageid'])) $_GET['pageid'] = VIEW_PROCEDURE?>
		RenderPage ( '../Common/renderpage.php?pageid=<?php echo $_GET['pageid']?>');
    }

    function loadpage ( pageid )
    {
		window.location.href = './index.php?pageid='+pageid;
		document.getElementById(pageid).classList.add("activate");
    }

  function activate_item(pageid)
	{
		var x = document.getElementsByClassName("nav-item");
		document.getElementById(pageid);
		var i;
		for ( i = 0; i < x.length; i++)
		{
			if(x[i].id == pageid)
			{
				x[i].classList.add("active");
			}
			else
			{
				x[i].classList.remove("active");
			}
		 }
    }

	var isloaded=false;
  </script>
</head>


<body id="page-top" onload="if(isloaded==false){init_page();isloaded=true; activate_item('<?php echo  $_GET['pageid'];?>');}">

  <nav id="idnavbar" class="navbar navbar-expand navbar-dark bg-dark static-top">

    <a class="navbar-brand mr-1" href="#" data-toggle="modal" data-target="#eoQUALInfo"><img src="../Common/pics/eoqual.png" style="height:30px"></a>
    <button class="btn btn-link btn-sm text-white order-1 order-sm-0" id="sidebarToggle" href="#">
      <i class="fas fa-bars"></i>
    </button>
    <!-- Navbar -->
    <ul class="navbar-nav ml-auto mr-0 mr-md-3 my-2 my-md-0">
      <li class="nav-item dropdown no-arrow">
        <a class="nav-link dropdown-toggle" href="#" id="userDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
          <i class="fas fa-user-circle fa-fw"></i><span><?php echo $_SESSION['lastname'];?></span>
        </a>
        <div class="dropdown-menu dropdown-menu-right" aria-labelledby="userDropdown">
          <a class="dropdown-item" href="../Common/logout.php">Logout</a>
        </div>
      </li>
    </ul>

  </nav>

  <div id="wrapper">
    <!-- Sidebar -->

    <ul id="usidebar" class="sidebar navbar-nav">

	  <!--  ################# DASHBOARD ###################### -->
	  <li class="nav-item" <?php if($_SESSION['view'][VIEW_DASHBOARD] == '0'){echo 'style="display:none;"';} ?> id="<?php echo VIEW_DASHBOARD;?>">
        <a class="nav-link" href="#" onClick="loadpage(this.parentNode.id);">
          <i class="fas fa-fw fa-tachometer-alt"></i>
          <span><?php echo $_Dashboard; ?></span>
        </a>
      </li>
	  <!--  ################# LEGAL DOCUMENT ##################### -->
	  <li class="nav-item" <?php if($_SESSION['view'][VIEW_LEGALDOCUMENT] == '0' && $_SESSION['view'][VIEW_LEGALDOCUMENT_WORKING] == '0'){echo 'style="display:none;"';} ?> id="<?php echo VIEW_LEGALDOCUMENT;?>">
		<div class="row1">
			<div class=<?php echo ColorAlert ( VIEW_LEGALDOCUMENT ); ?> ></div>
			<div class="TextTab" id="<?php echo VIEW_LEGALDOCUMENT;?>">
				<a class="nav-link" href="#" onClick="loadpage(this.parentNode.id);">
					<i class="fas fa-fw fa-file-export" aria-hidden="true"></i>
					<span><?php echo $_LegalDocument; ?></span>
				</a>
			</div>
		</div>
    </li>

	  <!--  ################# PROCEDURES ##################### -->
	  <li class="nav-item" <?php if($_SESSION['view'][VIEW_PROCEDURE] == '0' && $_SESSION['view'][VIEW_PROCEDURE_WORKING] == '0'){echo 'style="display:none;"';} ?> id="<?php echo VIEW_PROCEDURE;?>">
		<div class="row1" >
			<div class=<?php echo ColorAlert ( VIEW_PROCEDURE ); ?> ></div>
			<div class="TextTab" id="<?php echo VIEW_PROCEDURE;?>">
				<a class="nav-link" href="#" onClick="loadpage(this.parentNode.id);">
					<i class="fas fa-fw fa-file-contract"></i>
					<span><?php echo $_Procedure; ?></span>
				</a>
			</div>
		</div>
      </li>

    <!--  ################# EXAMLIST ##################### -->
	  <li class="nav-item" <?php if($_SESSION['view'][VIEW_EXAMLIST] == '0' && $_SESSION['view'][VIEW_EXAMLIST_WORKING] == '0'){echo 'style="display:none;"';} ?> id="<?php echo VIEW_EXAMLIST;?>">
		<div class="row1">
			<div class=<?php echo ColorAlert ( VIEW_EXAMLIST ); ?> >		</div>
			<div class="TextTab" id="<?php echo VIEW_EXAMLIST;?>">
				<a class="nav-link" href="#" onClick="loadpage(this.parentNode.id);">
					<i class="fas fa-fw fa-list-ol"></i>
					<span><?php echo $_Examslist; ?></span>
				</a>
			</div>
		</div>
      </li>

	  <!--  ################# STAFF ####################### -->
	  <li class="nav-item" <?php if($_SESSION['view'][VIEW_STAFF] == '0'){echo 'style="display:none;"';} ?> id="<?php echo VIEW_STAFF;?>">
		<div class="row1">
			<!-- <div <?php echo 'class="AlertTab"'; ?> style=<?php echo ColorAlert ( VIEW_STAFF ); ?> >		</div> -->
			<div class=<?php echo ColorAlert ( VIEW_STAFF ); ?> >	</div>
			<div class="TextTab" id="<?php echo VIEW_STAFF;?>">
				<a class="nav-link" href="#" onClick="loadpage(this.parentNode.id);">
					<i class="fa fa-fw fa-users" aria-hidden="true"></i>
					<span><?php echo $_Staff; ?></span>
				</a>
			</div>
		</div>
      </li>

	  <!--  ################# DEVICES ##################### -->
	  <li class="nav-item" <?php if($_SESSION['view'][VIEW_DEVICE] == '0'){echo 'style="display:none;"';} ?> id="<?php echo VIEW_DEVICE;?>">
		<div class="row1">
			<div class=<?php echo ColorAlert ( VIEW_DEVICE ); ?> >		</div>
			<div class="TextTab" id="<?php echo VIEW_DEVICE;?>">
				<a class="nav-link" href="#" onClick="loadpage(this.parentNode.id);">
					<i class="fa fa-fw fa-server" aria-hidden="true"></i>
					<span><?php echo $_Device; ?></span>
				</a>
			</div>
		</div>
      </li>



	  <!--  ################# DOSIMETRY ##################### -->
	  <li class="nav-item" <?php if($_SESSION['view'][VIEW_DOSIMETRY] == '0'){echo 'style="display:none;"';} ?> id="<?php echo VIEW_DOSIMETRY;?>">
		<div class="row1">
			<div class=<?php echo ColorAlert ( VIEW_DOSIMETRY ); ?> >		</div>
			<div class="TextTab" id="<?php echo VIEW_DOSIMETRY;?>">
				<a class="nav-link" href="#" onClick="loadpage(this.parentNode.id);">
					<i class="fas fa-fw fa-radiation" aria-hidden="true"></i>
					<span><?php echo $_Dosimetry; ?></span>
				</a>
			</div>
		</div>
      </li>

	  <!--  ################# INCIDENT REPORTING ##################### -->
	  <li class="nav-item" <?php if($_SESSION['view'][VIEW_INCIDENTREPORTING] == '0'){echo 'style="display:none;"';} ?>  id="<?php echo VIEW_INCIDENTREPORTING;?>">
		<div class="row1">
			<div class=<?php echo ColorAlert ( VIEW_INCIDENTREPORTING ); ?> >		</div>
			<div class="TextTab" id="<?php echo VIEW_INCIDENTREPORTING;?>">
				<a class="nav-link" href="#" onClick="loadpage(this.parentNode.id);">
					<i class="fas fa-fw fa-exclamation" aria-hidden="true"></i>
					<span><?php echo $_IncidentReporting; ?></span>
				</a>
			</div>
		</div>
    </li>



	  <!--  ################# SCHEDULED TASK ##################### -->
	  <li class="nav-item" <?php if($_SESSION['view'][VIEW_SCHEDULEDTASK] == '0'){echo 'style="display:none;"';} ?> id="<?php echo VIEW_SCHEDULEDTASK;?>">
		<div class="row1">
			<div class=<?php echo ColorAlert ( VIEW_SCHEDULEDTASK ); ?> >		</div>
			<div class="TextTab" id="<?php echo VIEW_SCHEDULEDTASK;?>">
				<a class="nav-link" href="#" onClick="loadpage(this.parentNode.id);">
					<i class="fas fa-fw fa-tasks" aria-hidden="true"></i>
					<span><?php echo $_ScheduledTask; ?></span>
				</a>
			</div>
		</div>
      </li>

	  <!--  ################# AUDIT ########################## -->
	  <li class="nav-item" <?php if($_SESSION['view'][VIEW_AUDIT] == '0'){echo 'style="display:none;"';} ?> id="<?php echo VIEW_AUDIT;?>">
		<div class="row1">
			<div class=<?php echo ColorAlert ( VIEW_AUDIT ); ?> >		</div>
			<div class="TextTab" id="<?php echo VIEW_AUDIT;?>">
				<a class="nav-link" href="#" onClick="loadpage(this.parentNode.id);">
					<i class="fas fa-fw fa-thumbtack"></i>
					<span><?php echo $_Audit; ?></span>
				</a>
			</div>
		</div>
      </li>

	  <!--  ################# STATISTIC ########################## -->
	  <li class="nav-item" <?php if($_SESSION['view'][VIEW_STATISTIC] == '0'){echo 'style="display:none;"';} ?> id="<?php echo VIEW_STATISTIC;?>">
		<div class="row1">
			<div class=<?php echo ColorAlert ( VIEW_STATISTIC ); ?> >		</div>
			<div class="TextTab" id="<?php echo VIEW_STATISTIC;?>">
				<a class="nav-link" href="#" onClick="loadpage(this.parentNode.id);">
					<i class="fas fa-fw fa-chart-area"></i>
					<span><?php echo $_Statistic; ?></span>
				</a>
			</div>
		</div>
    </li>
	  <li><br/></li>
    <!--  ################# INSTITUTION DOCUMENT ##################### -->
   <li class="nav-item" <?php if($_SESSION['view'][VIEW_INSTITUTIONDOCUMENT] == '0'){echo 'style="display:none;"';} ?> id="<?php echo VIEW_INSTITUTIONDOCUMENT;?>">
         <a class="nav-link" href="#" onClick="loadpage(this.parentNode.id);">
           <i class="fas fa-fw fa-university" aria-hidden="true"></i>
           <span><?php echo $_Institution; ?></span>
         </a>
     </li>

	  <li class="nav-item" <?php
        if( $_SESSION['view'][VIEW_INSTITUTION] == '0'
            && $_SESSION['view'][VIEW_LOGINROLE] == '0'
            && $_SESSION['view'][VIEW_STAFF] == '0'
            && $_SESSION['view'][VIEW_STAFFROLE] == '0'
            && $_SESSION['view'][VIEW_TAG] == '0'
            && $_SESSION['view'][VIEW_WARNING] == '0')
        {
          echo 'style="display:none;"';
        }
        ?> id="settings">
        <a class="nav-link" href="#" onClick="loadpage(this.parentNode.id);">
        <i class="fas fa-fw fa-cog" aria-hidden="true"></i>
          <span><?php echo $_Settings; ?></span>
        </a>
      </li>
	  <li class="nav-item" id="fastincidentreporting">
        <a class="nav-link" href="#" onClick="loadpage(this.parentNode.id);">
        <i class="fas fa-fw fa-exclamation-triangle" aria-hidden="true" style="color:rgb(242, 73, 61)"></i>
          <span style="color:rgb(242, 73, 61)"><?php echo $_ReportAnIncident;?></span>
        </a>
      </li>
    </ul>

    <div id="content-wrapper">
      <div class="container-fluid">
        <div id="page_content">
          </div>
      </div>

    </div>
  </div>

  <!-- Scroll to Top Button-->
  <a class="scroll-to-top rounded" href="#page-top">
    <i class="fas fa-angle-up"></i>
  </a>

  <!-- Logout Modal-->
  <div class="modal fade" id="eoQUALInfo" tabindex="-1" role="dialog" aria-labelledby="" aria-hidden="true">
  <div class="modal-dialog" role="document">

    <div id="div_about_Content" style="border-radius:6px 6px 6px 6px ;width:600px;height:500px; background-color:white;" onclick="event.stopPropagation();">
    <div class="bg-dark" style="border-radius:6px 6px 0px 0px;padding-top:15px;padding-bottom:8px;color:white;font-size:large;">
      <center>About eoQUAL</center>
    </div>
    <div style="float:left;width:55%;height:100%;padding-left:10px;font-family:Arial;">
  <br><br><b><u><span style="padding-left:20px;display:block;font-size:large">Informations de l'entreprise</span></u></b><br>
     <img style="height:60px" src="../Common/pics/logo_ximeo.png"><br>
     <span style="padding-left:20px;display:block;"><br>Ximeo SA<br>Rue de Gozée, 243<br>6110 MONTIGNY-LE-TILLEUL<br>BELGIQUE
      <br><br><a href:"mailto:support@ximeo.be"="">EMail : support@ximeo.be</a></span><a href:"mailto:support@ximeo.be"="">
    </a>
  <br><img src="../Common/pics/Consult_user_guide-small.bmp" style="height:30px;padding-left:20px;">&nbsp;&nbsp;&nbsp;Consulter le guide d'utilisation
</div><a href:"mailto:support@ximeo.be"="">

  <div style="float:left;width:35%;height:auto;padding-left:10px;font-family:Arial;">
      <br><br><b><u><span style="padding-left:20px;display:block;font-size:large;">Le logiciel</span></u></b><br>
     <img src="../Common/pics/CE.png" style="height:30px;padding-left:20px;"><span style="font-size:x-large;"></span>
     <span style="padding-left:20px;display:block;"><br><b>eoQUAL Quality</b><br>
   <br><B><?php echo $_Version; ?> : </B>&nbsp;&nbsp;&nbsp;1.0&nbsp;<font color="red"></font>
    </span>
    </div>
  </a>
  </div>
</div>


 <script>

 if (window.attachEvent)
  window.attachEvent("onresize",resizeLayout);
 else
  window.addEventListener("resize",resizeLayout, false);


 function resizeDoc(){
   var target = document.querySelector('#layout');
   var usidebar = document.querySelector('#usidebar');
   var idnavbar = document.querySelector('#idnavbar');
   var initw = getComputedStyle(target).width;
   var inith = getComputedStyle(target).height;
   target.style.width = "calc(100% - 40px - "+ usidebar.offsetWidth + "px)";
   target.style.height ="calc(100% - 0px - "+ idnavbar.offsetHeight + "px)";

 }
 var t;

 function resizeLayout(){

  window.clearTimeout(t);
  t = window.setTimeout(function(){


    //  var target = document.querySelector('#layout');
    //
    //  //target.style.width = "calc(100% - 500px)";
    //  var usidebar = document.querySelector('#usidebar');
    //  var idnavbar = document.querySelector('#idnavbar');
    //  target.style.width = "calc(100% - 30px - "+ usidebar.offsetWidth + "px)";
    //  target.style.height ="calc(100% - 70px - "+ idnavbar.offsetHeight + "px)";
    // // target.style.width = contentw.offsetWidth;
    // // target.style.height = contentw.offsetHeight;
    //
    //  myLayout.setSizes(false);
    var target = document.querySelector('#layout');
    var usidebar = document.querySelector('#usidebar');
    var idnavbar = document.querySelector('#idnavbar');
    var initw = getComputedStyle(target).width;
    var inith = getComputedStyle(target).height;
    target.style.width = "calc(100% - 40px - "+ usidebar.offsetWidth + "px)";
    target.style.height ="calc(100% - 30px - "+ idnavbar.offsetHeight + "px)";
    // var initw2 = getComputedStyle(target).width;
    // var inith2 = getComputedStyle(target).height;
    // console.log(initw + ' ---- ' + initw2);
    // console.log(inith + ' ---- ' + inith2);
    // console.log(parseFloat(initw));
    // var w = parseFloat(initw)-parseFloat(initw2);
    // var h = parseFloat(inith)-parseFloat(inith2);
   // target.style.width = '';
   // target.style.height = '';

    // myLayout.otherwidth = w;
    // myLayout.otherheight =  h;

   //  myLayout.setOffsets({
   //     top:0,
   //     right: w,
   //     bottom: h,
   //     left: 0
   // });
   if(myLayout != null){
    myLayout.setSizes(false);
   }
  },200);
 }

 </script>

 <!-- Custom scripts for all pages-->
 <script src="js/sb-admin.js"></script>

 <script src="/extern_css/bootstrap-4.5.3/js/bootstrap.bundle.min.js"></script>
 <!-- Page level plugin JavaScript-->
  <script src="chart/Chart.bundle.min.js" type="text/javascript"></script>
  <script src="chart/utils.js"></script>
  <script src="chart/errorbar.js"></script>
  <script src="chart/chartjs-plugin-annotation.min.js"> </script>

  <script src="/extern_css/chart.js/Chart.js"></script>
  <script src="/extern_css/hammer/hammer.js"></script>
  <script src="/extern_css/chartjs-zoom/chartjs-plugin-zoom.js"></script>
</body>

</html>
