<?php
  include 'autoload.php';
 ?>
<!DOCTYPE html>
<html lang="en">

<head>

  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <meta name="description" content="">
  <meta name="author" content="">
  <link rel="stylesheet" type="text/css" href="/dhtmlx/codebase/fonts/font_roboto/roboto.css"/>
  <link rel="stylesheet" type="text/css" href="/dhtmlx/codebase/dhtmlx.css"/>
  <link rel="stylesheet" type="text/css" href="/dhtmlx/skins/web/dhtmlx.css"/>
  <link rel="stylesheet" type="text/css" href="/extern_css/bootstrap-4.5.3/css/bootstrap.min.css"/>
  <link rel="shortcut icon" type="image/x-icon" href="../Common/pics/eoqual.png" />
  <script type='text/javascript' src="/dhtmlx/codebase/dhtmlx.js"></script>

  <title>Settings</title>

  <!-- Custom fonts for this template-->
  <link href="/extern_css/font-awesome-current/css/all.min.css" rel="stylesheet" type="text/css">

  <script src="./js/jquery/jquery.min.js"></script>

  <!-- Core plugin JavaScript-->
  <script src="./js/jquery-easing/jquery.easing.min.js"></script>
  <!-- Custom styles for this template-->
  <link href="./css/sb-admin.css" rel="stylesheet">

  <style>

  /*fix bug with bootstrap (grid resize after research)*/
	*, *::before, *::after {
		box-sizing: content-box;
	}
  div#layout {
		position: absolute;
		margin:0 auto;
    overflow: hidden;
		width: 100%;
		height: 100%;
	}
  </style>

  <script>


var tree_institution_menu = null;
var tree_institution = null;
var tree_linked_form = null;
var myLayout = null;

<?php create_translate_xml_js_function(); ?>

function loadtreeItem(id)
{
		tree_institution.selectItem(id);
}
//current position
function 	update_breadcrumb(id,advancedsettings = false)
{

	var divbread = document.querySelector('#breadcrumb_tree');
	var textnode = tree_institution.getItemText(id);
	var type = tree_institution.getUserData(id,'nodetype');
	var breadhtml = '<ol class="breadcrumb arr-right">';

	var ids = [];
	switch(type)
	{
		case 'modality':
					ids.push(id);
					id = tree_institution.getParentId(id);
		case 'room':
					ids.push(id);
					id = tree_institution.getParentId(id);
		case 'department':
					ids.push(id);
					id = tree_institution.getParentId(id);
		case 'institution':
					ids.push(id);
		default:break;
	}

	ids.reverse();


	for(var i = 0; i < ids.length; i++)
	{
		if(i == ids.length-1)
		{
			if(advancedsettings == false)
			{
				breadhtml += '<li class="breadcrumb-item active">';
				breadhtml += tree_institution.getItemText(ids[i])+'</li>';
			}else{
				breadhtml += '<li class="breadcrumb-item">';
				breadhtml += '<a onclick="window.tree_institution.clearSelection();window.tree_institution.selectItem(\''+ids[i]+'\');" href="#">'+tree_institution.getItemText(ids[i])+'</a></li>';
				breadhtml += '<li class="breadcrumb-item active">';
				breadhtml += 'Profile ' + tree_institution.getItemText(ids[i])+'</li>';
			}
		}else{
			breadhtml += '<li class="breadcrumb-item">';
			breadhtml += '<a onclick="window.tree_institution.selectItem(\''+ids[i]+'\');" href="#">'+tree_institution.getItemText(ids[i])+'</a></li>';
		}
	}

	if(type == 'modality')
	{
		breadhtml += '<ul class="ml-auto"><a onclick="window.load_advancedsettings(\''+ids[ids.length-1]+'\');" href="#"><i class="fas fa-fw fa-cogs"></i></a></ul>';
	}

	breadhtml += '</ol>'

	divbread.innerHTML = breadhtml;

}



function onMenuItemClick(menuitemId,type){
	 var id = tree_institution.contextID;
	 var nodetype =  tree_institution.getUserData(id,'nodetype');
   switch(menuitemId)
   {
     case 'mnewinstitution':
		 			new_node(id,nodetype);
		 break;
     case 'mnewdepartment':
		 			if(nodetype == 'institution'){
						new_node(id,'department');
					}
					else {//
						id = tree_institution.getParentId(id);
						new_node(id,nodetype);
					}
		 break;
     case 'mnewroom':
					 if(nodetype == 'department'){
						 new_node(id,'room');
					 }
					 else {
						 id = tree_institution.getParentId(id);
						 new_node(id,nodetype);
					 }
		 break;
     case 'mnewmodality':
					 if(nodetype == 'room'){
						 new_node(id,'modality');
					 }
					 else {
						 id = tree_institution.getParentId(id);
						 new_node(id,'modality');
					 }
		 break;
     case 'mcollapse':tree_institution.closeAllItems(id);break;
     case 'mexpand':tree_institution.openAllItems(id);break;
     case 'mdelete':
        var dbid = tree_institution.getUserData(id,'dbid');
        if(tree_institution.getUserData(id,'dbid') == '-1')
        {
          dhtmlx.alert({
            title:"Alert",
            type:"alert-error",
            text:"You can't delete these settings"
          });
        }else{
          dhtmlx.confirm({
            title:"Warning",
            ok:"Yes", cancel:"No",
            type:"alert-error",
            text:"Delete " + tree_institution.getItemText(id) + "?",
            callback:function(result){
              if(result)
              {
                delete_node(id);
              }
            }
          });
        }
     break;
     default: break;
   }
}

function create_context_menu(){
    tree_institution_menu = new dhtmlXMenuObject();
		tree_institution_menu.renderAsContextMenu();
		tree_institution_menu.attachEvent("onClick",onMenuItemClick);
		tree_institution_menu.loadStruct(translate_xml('/eoDACS/form_template/settings/treecontextmenu.xml'));
}

function load_institution(id)
{
  tree_linked_form = myLayout.cells('c').attachForm();
  tree_linked_form.loadStruct(translate_xml('/eoDACS/form_template/settings/institutionform.xml'),function(){
    tree_linked_form.load('dbconnector/settings/db_institutionform.php?id='+id);
  });
  var  formDP = new dataProcessor('dbconnector/settings/db_institutionform.php');
  formDP.init(tree_linked_form);
  formDP.attachEvent("onAfterUpdate", onFormUpdated);
  tree_linked_form.attachEvent("onButtonClick", onFormButtonClick);
}
function load_department(id)
{
  tree_linked_form = myLayout.cells('c').attachForm();
  tree_linked_form.loadStruct(translate_xml('/eoDACS/form_template/settings/departmentform.xml'),function(){
    tree_linked_form.load('dbconnector/settings/db_departmentform.php?id='+id);
  });
  var  formDP = new dataProcessor('dbconnector/settings/db_departmentform.php');
  formDP.init(tree_linked_form);
  formDP.attachEvent("onAfterUpdate", onFormUpdated);
  tree_linked_form.attachEvent("onButtonClick", onFormButtonClick);
}

function load_room(id)
{
  tree_linked_form = myLayout.cells('c').attachForm();
  tree_linked_form.loadStruct(translate_xml('/eoDACS/form_template/settings/roomform.xml'),function(){
    tree_linked_form.load('dbconnector/settings/db_roomform.php?id='+id);
  });
  var  formDP = new dataProcessor('dbconnector/settings/db_roomform.php');
  formDP.init(tree_linked_form);
  formDP.attachEvent("onAfterUpdate", onFormUpdated);
  tree_linked_form.attachEvent("onButtonClick", onFormButtonClick);
}

function load_modality(id)
{

	var layout2U = myLayout.cells('c').attachLayout('3U');
	var cellForm = layout2U.cells('a');
	cellForm.hideHeader();
	cellForm.setWidth(350);
  tree_linked_form = cellForm.attachForm();
  tree_linked_form.loadStruct(translate_xml('/eoDACS/form_template/settings/modalityform.xml'),function(){
    tree_linked_form.load('dbconnector/settings/db_modalityform.php?id='+id);
  });
  var  formDP = new dataProcessor('dbconnector/settings/db_modalityform.php');
  formDP.init(tree_linked_form);
  formDP.attachEvent("onAfterUpdate", onFormUpdated);
  tree_linked_form.attachEvent("onButtonClick", onFormButtonClick);

	var cellLinkedID = layout2U.cells('b');
	cellLinkedID.setText("Linked identities");
	cellLinkedID.hideArrow();
	var gridlinked_identity = cellLinkedID.attachGrid();
	gridlinked_identity.load("dbconnector/settings/db_gridmodalityidentity.php?dhx_filter[0]="+id);
	gridlinked_identity.attachEvent("onRowDblClicked", function(rId,cInd){
		// your code here
		var sInd = gridlinked_identity.getColIndexById('shortcut_remove');
		if(cInd == sInd)
		{
			gridlinked_identity.deleteRow(rId);
		}

		return true;
	});

	var gridlinked_identityDP = new dataProcessor('dbconnector/settings/db_dp_gridmodalityidentity.php');
	gridlinked_identityDP.init(gridlinked_identity);
	gridlinked_identityDP.enableDataNames(true);

	var cellOthersID = layout2U.cells('c');
	cellOthersID.setText("Other identities");
	cellOthersID.collapse();
	gridother_identity = cellOthersID.attachGrid();
	gridother_identity.load("dbconnector/settings/db_gridmodalityidentity_diff.php?dhx_filter[0]="+id);
	var gridother_identityDP = new dataProcessor('dbconnector/settings/db_dp_gridmodalityidentity_diff.php');
	gridother_identityDP.init(gridother_identity);
	gridother_identityDP.enableDataNames(true);

	gridother_identity.attachEvent("onRowDblClicked", function(rId,cInd){
    // your code here
		var sInd = gridother_identity.getColIndexById('shortcut_add');
		if(cInd == sInd)
		{
			var indModidentID = gridother_identity.getColIndexById('modident_id');
			var indStatus = gridother_identity.getColIndexById('status');

			var modident_id = gridother_identity.cells(rId,indModidentID).getValue();
			var status = gridother_identity.cells(rId,indStatus).getValue();
			gridother_identity.deleteRow(rId);
			gridlinked_identity.addRow(modident_id,[modident_id,id,'','','','','','','','',status]);

		}
		return true;
	});

	gridlinked_identityDP.attachEvent("onAfterUpdate", function(sid, action, tid, tag){
		if (action == "inserted"){

		}
		if (action == "updated"){

			gridlinked_identity.updateFromXML("dbconnector/settings/db_gridmodalityidentity.php?dhx_filter[0]="+id,true,true);

		}

		if (action == "deleted"){

			gridother_identity.updateFromXML("dbconnector/settings/db_gridmodalityidentity_diff.php?dhx_filter[0]="+id,true,true);
		}
	})

}

function load_advancedsettings(id)
{
	update_breadcrumb(id,true);
	var dbid = tree_institution.getUserData(id,'dbid');
 	var advancedlayout = myLayout.cells('c').attachLayout('3U');
	var a = advancedlayout.cells('a');
	a.setText('Linked profiles');
	var grid_linkedprofile = a.attachGrid();
	grid_linkedprofile.setImagesPath("/dhtmlx/codebase/imgs/dhxgrid_web/");
	grid_linkedprofile.enableMultiline(true);
	grid_linkedprofile.load("dbconnector/settings/db_gridmodalityprofile.php?modid="+dbid);

	var b = advancedlayout.cells('b');
	b.setText('Available profiles');
	var grid_availableprofile = b.attachGrid();
	grid_availableprofile.enableMultiline(true);
	grid_availableprofile.load("dbconnector/settings/db_gridmodalityprofile_diff.php?modid="+dbid);



	var cell_1 = advancedlayout.cells('c');
	cell_1.setText('Profile tags');
	var grid_profiletags = cell_1.attachGrid();
	grid_profiletags.load("dbconnector/settings/db_gridmodalityprofiledicomtag.php?proid=-1");

	grid_linkedprofile.attachEvent("onRowSelect", function(id,ind){
			grid_profiletags.clearAll();
			grid_profiletags.updateFromXML("dbconnector/settings/db_gridmodalityprofiledicomtag.php?proid="+id);
	});



	var grid_profiletagsDP = new dataProcessor('dbconnector/settings/db_dp_gridmodalityprofiledicomtag.php');
  grid_profiletagsDP.init(grid_profiletags);
  grid_profiletagsDP.enableDataNames(true);

  grid_profiletagsDP.attachEvent("onAfterUpdate", function(sid, action, tid, tag){

    if (action == "inserted"){
        dhtmlx.message("inserted");

    }

    if (action == "updated"){
        dhtmlx.message("updated");
				// dp.ignore(function(){
				//   grid_profiletags.updateFromXML("dbconnector/settings/db_gridmodalityprofiledicomtag.php?proid="+id);
				// });
    }

    if (action == "deleted"){
        dhtmlx.message("deleted");

    }
  })

}
function delete_node(id)
{
  var xhr = new XMLHttpRequest();
  var data = {};
  data['action'] = 'delete';
  data['id'] = tree_institution.getUserData(id,'dbid');
  data['type'] = tree_institution.getUserData(id,'nodetype');


  xhr.onreadystatechange = function() {
    if (xhr.readyState == 4 && (xhr.status == 200 || xhr.status == 0)) {
        var xmlDoc = xhr.responseXML;
        var x = xmlDoc.getElementsByTagName("status")[0];
        onTreeUpdated(x.childNodes[0].nodeValue);
    }
  };
  xhr.open ("POST", '/eoDACS/dbconnector/settings/dp_treeinstitution.php', true);
  xhr.setRequestHeader('Content-Type', 'application/json; charset=UTF-8');
  xhr.send(JSON.stringify(data));

}

function new_node(id,nodetype)
{
	var xhr = new XMLHttpRequest();
  var data = {};
  data['action'] = 'new';
  data['id'] = tree_institution.getUserData(id,'dbid');
  data['type'] = nodetype;


  xhr.onreadystatechange = function() {
    if (xhr.readyState == 4 && (xhr.status == 200 || xhr.status == 0)) {
        var xmlDoc = xhr.responseXML;
        var x = xmlDoc.getElementsByTagName("status")[0];
        onTreeUpdated(x.childNodes[0].nodeValue);
    }
  };
  xhr.open ("POST", '/eoDACS/dbconnector/settings/dp_treeinstitution.php', true);
  xhr.setRequestHeader('Content-Type', 'application/json; charset=UTF-8');
  xhr.send(JSON.stringify(data));
}


function move_node(sId,tId)
{
	var xhr = new XMLHttpRequest();
	var data = {};
	data['action'] = 'move';
	data['sid'] = tree_institution.getUserData(sId,'dbid');
	data['tid'] = tree_institution.getUserData(tId,'dbid');
	data['type'] = tree_institution.getUserData(sId,'nodetype');


	xhr.onreadystatechange = function() {
		if (xhr.readyState == 4 && (xhr.status == 200 || xhr.status == 0)) {
				var xmlDoc = xhr.responseXML;
				var x = xmlDoc.getElementsByTagName("status")[0];
				onTreeUpdated(x.childNodes[0].nodeValue);
		}
	};
	xhr.open ("POST", '/eoDACS/dbconnector/settings/dp_treeinstitution.php', true);
	xhr.setRequestHeader('Content-Type', 'application/json; charset=UTF-8');
	xhr.send(JSON.stringify(data));

}

function onTreeUpdated(action)
{
  switch(action)
  {
    case 'inserted': tree_institution.smartRefreshBranch(tree_institution.getSelectedItemId());dhtmlx.message("Ajout réussi!"); break;
    case 'updated': tree_institution.smartRefreshBranch(0);dhtmlx.message("Modification réussie!"); break;
    case 'deleted': tree_institution.smartRefreshBranch(0);dhtmlx.message("Suppréssion réussie!"); break;
		case 'silent':break;
    default:dhtmlx.message('unknow return');break;
  }
}

function onFormUpdated(sid, action, tid, tag){
  if (action == "inserted"){
    dhtmlx.message("Ajout réussi!");

  }

  if (action == "updated"){
    dhtmlx.message("Modification réussie!");
    tree_institution.smartRefreshBranch(tree_institution.getSelectedItemId());
  }


  if (action == "deleted"){
    dhtmlx.message("Suppréssion réussie!");
  }
};

function onFormButtonClick(name)
{
  switch(name)
  {
    case 'bsave': tree_linked_form.save();
    default:break;
  }
}


function init_layout(){
  window.dhx4.skin = 'dhx_web';
  myLayout = new dhtmlXLayoutObject('layout', '3L');

  create_context_menu();
  var ad = "/extern_css/font-awesome-current/svgs/solid/angle-down.svg";
  var ar = "/extern_css/font-awesome-current/svgs/solid/angle-right.svg";
  var a = myLayout.cells('a');
  a.setWidth('350');

	var layout2E = a.attachLayout('2E');

	var cell_1 = layout2E.cells('a');
	cell_1.setHeight('70');
	cell_1.hideHeader();
	cell_1.fixSize(0,1);
	cell_1.attachObject('searchInTree');

	var cell_2 = layout2E.cells('b');
	cell_2.hideHeader();


  tree_institution =	cell_2.attachTree();
	window.tree_institution = tree_institution;

  tree_institution.setImageArrays("plus",ar,ar,ar,ar,ar);
  tree_institution.setImageArrays("minus",ad,ad,ad,ad,ad);

  tree_institution.enableKeyboardNavigation(1);
  tree_institution.enableContextMenu(tree_institution_menu);

	tree_institution.enableDragAndDrop(true);
	tree_institution.setXMLAutoLoading("dbconnector/settings/db_treeinstitutionsetup.php");
	tree_institution.load("dbconnector/settings/db_treeinstitutionsetup.php",function(){
		tree_institution.openAllItems("0");
	});

	//define the comparator (in our case it compares the second words in labels)


	// tree_institution.setCustomSortFunction(function mySortFunc(idA,idB){
	//     a= tree_institution.getItemText(idA);
	//     b=ree_institution.getItemText(idB);
	//     return (a>b)? 1 : ((a<b) ? -1 : 0);
	// });

  tree_institution.attachEvent("onBeforeContextMenu", function(id){

    //select the left click item
    if(tree_institution.getSelectedItemId() != id)
    {
      tree_institution.selectItem(id,true);
    }

    var type = tree_institution.getUserData(id,'nodetype');
		var dbid = tree_institution.getUserData(id,'dbid');

    switch(type)
    {
      case 'institution':
        tree_institution_menu.showItem('mnewinstitution');
        tree_institution_menu.showItem('mnewdepartment');
        tree_institution_menu.hideItem('mnewroom');
        tree_institution_menu.hideItem('mnewmodality');
      break;
      case 'department':
        tree_institution_menu.hideItem('mnewinstitution');
        tree_institution_menu.showItem('mnewdepartment');
        tree_institution_menu.showItem('mnewroom');
        tree_institution_menu.hideItem('mnewmodality');
      break;
      case 'room':
        tree_institution_menu.hideItem('mnewinstitution');
        tree_institution_menu.hideItem('mnewdepartment');
        tree_institution_menu.showItem('mnewroom');
        tree_institution_menu.showItem('mnewmodality');
      break;
      case 'modality':
        tree_institution_menu.hideItem('mnewinstitution');
        tree_institution_menu.hideItem('mnewdepartment');
        tree_institution_menu.hideItem('mnewroom');
        tree_institution_menu.showItem('mnewmodality');
      break;
      default: break;
    }
    return true;
  });



  tree_institution.attachEvent("onSelect", function(id){
      // your code here
      var type = tree_institution.getUserData(id,'nodetype');
      var dbid = tree_institution.getUserData(id,'dbid');
      switch(type)
      {
        case 'institution': load_institution(dbid);break;
        case 'department': load_department(dbid);break;
        case 'room': load_room(dbid);break;
        case 'modality':load_modality(dbid);break;
        default: break;
      }

			update_breadcrumb(id);
  });

	 var dragAllowType = [];
	 dragAllowType['institution'] = '';
	 dragAllowType['department'] = 'institution';
	 dragAllowType['room'] = 'department';
	 dragAllowType['modality'] = 'room';


	 	tree_institution.attachEvent("onBeforeDrag", function(sId){
			 // your code here
			 if(tree_institution.getUserData(sId,'nodetype') =='institution' || tree_institution.getUserData(sId,'dbid') == '-1')
			 	return false;

				return true;
		});
		//Drag and Drop
		tree_institution.attachEvent("onDragIn", function(sId, tId, sObject, tObject){
    // your code here


		var stype=sObject.getUserData(sId,'nodetype');
		var ttype=tObject.getUserData(tId,'nodetype');


		if(dragAllowType[stype] != ttype)
		{
			return false;
		}

		return true;

	});

	tree_institution.attachEvent("onDrop", function(sId, tId, id, sObject, tObject){
    // your code here
		move_node(sId,tId);
		return true;
	});

  var b = myLayout.cells('b');
  b.hideHeader();
  b.setHeight('70');
  b.fixSize(0,1);
  b.attachObject('treepos');
  var c = myLayout.cells('c');
	myLayout.cells('c');
  c.hideHeader();

	window.load_advancedsettings = load_advancedsettings;
	window.myLayout = myLayout;
}


</script>

<body>

<div id="layout"/>
<div id="treepos">
  <div id="breadcrumb_tree" class="container-fluid">
  <!-- Breadcrumbs-->
  </div>
</div>
<div id="vp" width="300" height="400"></div>
<div id="searchInTree" class="input-group">
	<input id="searchInTreeEnter" type="text" class="form-control" placeholder="Search for..." aria-label="Search" aria-describedby="basic-addon2">
	<div class="input-group-append">
		<button id="searchInTreeBClick" class="btn btn-primary" type="button">
			<i class="fas fa-search"></i>
		</button>
	</div>
</div>

<script>

init_layout();

if (typeof resizeLayout !== "function") {

  if (window.attachEvent)
  window.attachEvent("onresize",resizeLayout);
  else
  window.addEventListener("resize",resizeLayout, false);


  var t;

  function resizeLayout(){
  	window.clearTimeout(t);
  	t = window.setTimeout(function(){
     if(myLayout != null){
     // target.style.width = contentw.offsetWidth;
     // target.style.height = contentw.offsetHeight;

  		 myLayout.setSizes(false);
    }
  	},200);
  }

}

</script>

<script>
var node = document.getElementById('searchInTreeEnter');
node.addEventListener("keyup", function(event) {
    if (event.key === "Enter") {
			tree_institution.findItem(event.target.value);
    }
});
node = document.getElementById('searchInTreeBClick');
node.addEventListener("click", function(event) {
		tree_institution.findItem(document.getElementById("searchInTreeEnter").value);
});
</script>
</body>
</html>
