class C_FileManager
{
  constructor ()
  {
    this.data = {};
    this.versioning = 0;
    this.form_document = null;
    this.window_formdoc = null;
    this.set_data('url_form_xml','/eoQUAL/Main/form_template/common/fileform.php');
    this.set_data('url_dp_form','/eoQUAL/Main/dbconnector/common/db_dp_filedocument.php');
    // this.set_data('url_form','/eoQUAL/Main/dbconnector/common/db_filedocument.php');
	this.set_data('url_form','/eoQUAL/Main/dbconnector/common/db_formdocument.php');
    this.set_data('url_grid','/eoQUAL/Main/dbconnector/common/db_filedocument.php');
    this.set_data('uniquedoc','0');
  }

  init_form ()
  {
    this.form_document.setItemValue('document_type',this.data['type']);
    if(C_FileManager.EDITVERSION == this.data['documentmode'])
    {
      this.form_document.resetDataProcessor("updated");
    }else{
      this.form_document.resetDataProcessor("inserted");
    }

    if(this.data['documentmode'] == C_FileManager.NEWVERSION)
      this.form_document.setItemValue('name',this.data['name']);
    else
      this.form_document.setItemValue('name','');

    this.form_document.setItemValue('label','');
    this.form_document.setItemValue('comment','');
    this.form_document.setItemValue('uploaded_by',this.data['staffid']);
    this.form_document.setItemValue('ext_id',this.data['extid']);
    this.form_document.setItemValue('create_date',new Date());
    if(this.data['documentmode'] == C_FileManager.NEWDOCUMENT)
      this.form_document.setItemValue('revision','1');
    else{
      this.form_document.setItemValue('revision','');
    }
  }

  set_data(key,value)
  {
    this.data[key] = value;
  }

  get_form()
  {
    return this.form_document;
  }

  clear(){
    this.reset_document_form();
    this.grid_document.clearAll();
  }

  update_toolbar(){
    if(this.grid_document.getRowsNum() >0 && this.data['uniquedoc'] == '1')
    {
      this.toolbar_griddocument.hideItem('add');
    }else{
      this.toolbar_griddocument.showItem('add');
    }
  }

  init_object ( grid_documentparent,toolbar_griddocument,grid_document)
  {
    this.grid_document = grid_document;
    this.grid_documentparent = grid_documentparent;
    this.toolbar_griddocument = toolbar_griddocument;

    var _self = this;
    grid_documentparent.attachEvent
	(
		"onRowSelect", 
		function(id,ind)
		{
			grid_document.load 
			(
				_self.data['url_grid']+'?doctype='+_self.data['type']+'&versioning='+_self.versioning+'&extid='+id,
				function ()
				{
        if(_self.versioning == 1)
        {
          var idx = grid_document.getColIndexById('doc_master_groupid');
          var idxrev = grid_document.getColIndexById('revision');
          grid_document.groupBy(idx,["","","#title","#cspan","#cspan","#cspan","#cspan","#cspan","#cspan","#cspan"]);
          grid_document.sortRows(idxrev,"int","desc");
        }
        _self.update_toolbar();
				}
			);
		}
	);


    grid_document.setImagesPath("/dhtmlx/codebase/imgs/dhxgrid_web/");
    grid_document.customGroupFormat=function(text,count)
	{
      return text.substr(0, text.lastIndexOf("_"))+" ("+count+")";
    };

    grid_document.load(this.data['url_grid']+'?doctype='+_self.data['type']+'&versioning='+this.versioning);
	
	grid_document.attachEvent
	(
		"onRowSelect", 
		function ( id, ind )
		{
      var downloadidx= grid_document.getColIndexById('shortcut_download');
			var editidx		= grid_document.getColIndexById ( 'shortcut_edit'		);

      switch(ind)
      {
				case editidx:
				{
					// var extID 		= grid_documentparent.getSelectedRowId ();
					// _self.set_data('extid',extID);
					
					_self.setmode(C_FileManager.EDITVERSION);
					_self.load_document_form(id);
					_self.show();
				}
				break;
				
        case downloadidx:
        {
          var a = document.createElement("a");
          document.body.appendChild(a);
          var idd = 'docid'+id;
          a.id=idd;
          a.href="/eoQUAL/Common/download.php?docid="+id;
          a.click();
          document.body.removeChild(a);

      }
				break;
			}
		}
	);


    toolbar_griddocument.attachEvent("onStateChange", function(id, state){
      if(id == 'oldversion')
      {
        if(state == true)
        {
          _self.versioning=1;
        }else{
          _self.versioning=0;
        }

        var extID = grid_documentparent.getSelectedRowId();

        if(extID != null)
        {
          var docid = grid_document.getSelectedRowId();
          grid_document.clearAndLoad(_self.data['url_grid']+'?doctype='+_self.data['type']+'&versioning='+_self.versioning+'&extid='+extID,function(){
            if(_self.versioning == 1)
            {
              var idx = grid_document.getColIndexById('doc_master_groupid');
              var idxrev = grid_document.getColIndexById('revision');
              grid_document.groupBy(idx,["","","#title","#cspan","#cspan","#cspan","#cspan","#cspan","#cspan","#cspan"]);
              grid_document.sortRows(idxrev,"int","desc");
            }

            if(docid != null)
            {
              grid_document.selectRowById(docid);
            }
          });
        }
      }
    });

    grid_document.attachEvent("onXLE",function(){
      // your code here
      _self.update_toolbar();

    });

    toolbar_griddocument.attachEvent("onClick", function(id){

      var extID = grid_documentparent.getSelectedRowId();
      if(extID == null)
      {
        dhtmlx.message({
          type: "error",
          text: _self.data['noselection']
        })
        return;
      }
      _self.set_data('extid',extID);
      switch(id)
      {
        case 'add':{
          _self.setmode(C_FileManager.NEWDOCUMENT);
          _self.reset_document_form();
          _self.show();
        }break;
        case 'delete':
        {
          var docID = grid_document.getSelectedRowId();
          if(_self.versioning==1)
          {
            dhtmlx.message('Delete not available for a document version');
          }else{
          if(docID != null)
          {
              dhtmlx.confirm({
                title:"Delete document",
    						type:"confirm-error",
                ok:"Delete", cancel:"Cancel",
    						text:"Do you realy want to delete the selected document?",
    						      callback:function(result){
                        if(result == true){
                          _self.delete_document(docID);
                        }
    						      }
    					});
            }else{
              dhtmlx.message('No document selected');
            }
          }
        }break;
        default:
      }
    });
  }

  reset_document_form()
  {
      this.form_document.reset();
  }

  
  load_document_form(docid)
  {
    this.form_document.load(this.data['url_form']+'?id='+docid);
  }

  
  update_document_grid(docid)
  {
    var extID = this.grid_documentparent.getSelectedRowId();
    if(extID != null)
    {
      var _self = this;
      this.grid_document.updateFromXML(this.data['url_grid']+'?doctype='+this.data['type']+'&versioning='+this.versioning+'&extid='+extID,true,true,function(){
        _self.grid_document.selectRowById(docid);
      });
    }
  }

  delete_document(docID)
  {
    var data = {};
    data['action'] = 'delete';
    data['docid'] = docID;
    data['staffid'] = this.data['staffid'];
    var xhr = new XMLHttpRequest();
    xhr.open("POST", '/eoQUAL/Main/dbconnector/common/db_deletedocument.php', true);
    xhr.setRequestHeader('Content-Type', 'application/json; charset=UTF-8');
    var _self = this;
    xhr.onload = function (e) {
      if (xhr.readyState === 4) {
        if (xhr.status === 200) {
          var x,xmlDoc;
          x = xhr.responseXML.getElementsByTagName('data');
          x = x[0].getElementsByTagName('action');
          if(x.length > 0)
          {
            var event = new CustomEvent('onAfterDocumentDeleted',{
              detail: {
                docid: x[0].getAttribute('tid'),
                type: _self.data['type']
              }
            });

            document.dispatchEvent(event);

          }
        }else {
            console.error(xhr.statusText);
        }
      }
    };
    xhr.send(JSON.stringify(data));


  }



  init()
  {

    var winname = this.data['winname'];
    var uploadername =  this.data['uploadername'];
    var myLayout = this.data['layout'];
    var staffid = this.data['staffid'];


    if((this.window_formdoc = myLayout.dhxWins.window(winname)) == null)
    {

      this.window_formdoc = myLayout.dhxWins.createWindow(winname, 0, 0, 520, 500);


      this.form_document = this.window_formdoc.attachForm();
      this.form_document.enableLiveValidation(true);
      var _self = this;
      this.form_document.loadStruct 
	  ( 
		translate_xml 
		( 
			this.data['url_form_xml']+'?type='+this.data['type']),
			function ()
			{
        var uploader = _self.form_document.getUploader(uploadername);

				_self.form_document.attachEvent 
				(
					"onFileAdd",
					function(realName)
					{
            // your code
            uploader.buttons.browse.style.right= "28px";
            uploader.buttons.clear.style.display = "none";
            uploader.buttons.upload.style.display = "none";
            return true;
					}
				);

				_self.form_document.attachEvent
				(
					"onAfterReset", 
					function (id)
					{
            //your code here
            uploader.clear();
            _self.init_form();
					}
				);
        _self.reset_document_form();
			}
		);

      this.window_formdoc.setText(this.data['title_newdocument']);
      this.window_formdoc.centerOnScreen();
      this.window_formdoc.hide();
      this.window_formdoc.attachEvent("onClose", function(win){
          // your code here
          _self.window_formdoc.setModal(false);
          _self.window_formdoc.hide();
          _self.reset_document_form();
          return false;
      });

        this.window_formdoc.attachEvent("onShow", function(win){
          _self.init_form();
      });

      this.dp_form_document = new dataProcessor(this.data['url_dp_form']);
      this.dp_form_document.init(this.form_document);
      this.dp_form_document.attachEvent("onAfterUpdate",function(sid,action,tid,xml_node){ // update is finished
        if(action=='inserted' ){
          var event = new CustomEvent('onAfterDocumentInserted',{
            detail: {
              docid: tid,
              type: _self.data['type']
            }
          });

          document.dispatchEvent(event);
        }
        else if(action == 'updated')
        {
          var event = new CustomEvent('onAfterDocumentUpdated',{
            detail: {
              docid: tid,
              type: _self.data['type']
            }
          });

          document.dispatchEvent(event);
        }

      });

      this.dp_form_document.attachEvent("onBeforeDataSending", function(id, state, data) {
        for (const property in data) {
          //adding type and additionnal data
          data[property].documentmode = _self.data['documentmode'];
          data[property].documentparent = _self.data['documentparent'];
        }

        return true;
      });

      this.form_document.attachEvent("onButtonClick", function(name)
	  {
        if(name == 'save')
        {
          if(!_self.form_document.isItemHidden(uploadername+'fieldset'))
          {
            _self.form_document.getUploader(uploadername).upload();

            if(_self.form_document.getUploaderStatus(uploadername) == 0)
            {
              dhtmlx.alert({
                type:"alert-warning",
                text:"You need to upload a document.",
                callback:function(){

                }
              });
            }else{
              if(_self.form_document.getUploaderStatus(uploadername) != 1)
              {
                var evId = _self.form_document.attachEvent("onUploadComplete",function(count){
                    // your code here
                    dhtmlx.message('File uploaded');
                    _self.form_document.detachEvent(evId);
                    _self.form_document.save();
                    _self.window_formdoc.close();
                });
              }else{
                _self.form_document.save();
                _self.window_formdoc.close();
              }
            }
          }else{
            _self.form_document.save();
            _self.window_formdoc.close();
          }
        }
      });
    }

    this.form_document = this.window_formdoc.getAttachedObject();
  }

  //typeform in newdocument - newdocument - editversion
  setmode(typeform)
  {
      switch(typeform)
      {
        case C_FileManager.NEWDOCUMENT:
        {
          this.window_formdoc.setText(this.data['title_newdocument']);
          this.form_document.showItem(this.data['uploadername']+'fieldset');
          this.data['documentmode'] = C_FileManager.NEWDOCUMENT;
          this.data['documentparent'] = "";
        }break;
        case C_FileManager.NEWVERSION:
        {
          this.window_formdoc.setText(this.data['title_newversion']);
          this.form_document.showItem(this.data['uploadername']+'fieldset');
          this.data['documentmode'] = C_FileManager.NEWVERSION;
        }break;
        case C_FileManager.EDITVERSION:
        {
          this.window_formdoc.setText(this.data['title_editversion']);
          this.form_document.hideItem(this.data['uploadername']+'fieldset');
          this.data['documentmode'] = C_FileManager.EDITVERSION;
          this.data['documentparent'] = "";
        }break;
        default:
      }
  }

	show(){
    this.window_formdoc.setModal(true);
    this.window_formdoc.show();
	}

  hide(){
    this.window_formdoc.close();
  }
}


Object.defineProperty(C_FileManager, 'NEWDOCUMENT', {
    value: 'newdocument',
    writable : false,
    enumerable : true,
    configurable : false
});
Object.defineProperty(C_FileManager, 'NEWVERSION', {
    value: 'newversion',
    writable : false,
    enumerable : true,
    configurable : false
});
Object.defineProperty(C_FileManager, 'EDITVERSION', {
    value: 'editversion',
    writable : false,
    enumerable : true,
    configurable : false
});
